SystemOrganization addCategory: #'Ma object serialization-API'!
SystemOrganization addCategory: #'Ma object serialization-Info'!
SystemOrganization addCategory: #'Ma object serialization-exceptions'!
SystemOrganization addCategory: #'Ma object serialization-private'!
SystemOrganization addCategory: #'Ma object serialization-support'!

!ScriptEditorMorph methodsFor: '*ma object serialization' stamp: 'cmm 11/26/2004 14:35'!
maWantsPostMaterialization 
	^ true! !

!ScriptEditorMorph methodsFor: '*ma object serialization' stamp: 'cmm 11/26/2004 14:35'!
maWantsPreSerialization
	^ true! !

!Set class methodsFor: '*ma object serialization' stamp: 'cmm 11/22/2004 16:08'!
maIsLogicallyVariable
	"Answer whether, for ma serialization purposes, I am stored as a fixed or variable object."
	^ true! !

!Set class methodsFor: '*ma object serialization' stamp: 'cmm 12/2/2004 12:35'!
maLoadVariableObjectFrom: aMaVariableObjectBuffer

	| skeleton |
	skeleton _ self new: aMaVariableObjectBuffer objectInstSize.
	1
		to: aMaVariableObjectBuffer objectInstSize
		do: [ :index | skeleton add: (aMaVariableObjectBuffer maInstVarAt: index) ].
	^ skeleton! !

!Set methodsFor: '*ma object serialization' stamp: 'cmm 12/1/2004 22:55'!
maBufferInstSize

	^ self size! !

!Set methodsFor: '*ma object serialization' stamp: 'cmm 11/23/2004 10:26'!
maEstablishPointerReferencesUsing: aMaObjectSerializer
	"I am currently loaded with oids of the objects that I should be referencing.  Now that objects for these oids are, themselves, materialized, I can now replace my referernces to oids wtih references to the real objects."
	| fullOfOidsCopy |
	self isEmpty ifTrue: [ ^ self ]. "performance, avoid the copy if possible.."
	fullOfOidsCopy _ self copy.
	self maRemoveAll.
	fullOfOidsCopy do:
		[ :each |
		self
			add: (
				aMaObjectSerializer
					objectWithOid: each
					ifAbsent: [ aMaObjectSerializer proxyFor: each ]) ]! !

!Set methodsFor: '*ma object serialization' stamp: ''!
maIsHashedCollection

	^true
! !

!Set methodsFor: '*ma object serialization' stamp: 'cmm 11/28/2004 16:21'!
maStreamVariablyInto: aMaVariableBuffer for: aMaObjectSerializer
	"Put the receivers instance variables into aMaVariableObjectBuffer as they fit."

	| index |
	index _ 1.
	self do:
		[ : eachLinkedObject |
		aMaVariableBuffer
			maInstVarAt: index
			put:
				(aMaVariableBuffer 
					numberToStoreFor: eachLinkedObject
					using: aMaObjectSerializer).
		index _ index + 1 ].
	3 "skip array and tally, they're taken care of logically, above."
		to: self maInstSize
		do:
			[ : namedIndex |
			aMaVariableBuffer
				maInstVarAt: index + namedIndex
				put: (aMaObjectSerializer oidFor: (self instVarAt: namedIndex)) ]! !

!Project methodsFor: '*ma object serialization' stamp: 'cmm 11/29/2004 16:31'!
maTransientVariables
	"Don't store or traverse these variables when serializing me."
	^ #('parentProject' 'nextProject' 'previousProject')! !

!Project methodsFor: '*ma object serialization' stamp: 'cmm 11/26/2004 15:15'!
maWantsPostMaterialization 
	^ true! !

!Object class methodsFor: '*ma object serialization' stamp: 'cmm 6/11/2004 13:57'!
maInstancesRequireOwnBuffer
	^ true! !

!Object class methodsFor: '*ma object serialization' stamp: 'cmm 11/19/2004 15:20'!
maIsLogicallyVariable
	"Answer whether, for ma serialization purposes, I am stored as a fixed or variable object."
	^ self isVariable! !

!Object class methodsFor: '*ma object serialization' stamp: 'cmm 12/2/2004 12:35'!
maLoadVariableObjectFrom: aMaVariableObjectBuffer
	"This is the standard-case for building a skeleton of a variably-sized object."
	| skeleton |
	skeleton _ self basicNew: aMaVariableObjectBuffer objectInstSize.
	1
		to: aMaVariableObjectBuffer objectInstSize
		do:
			[ : index |
			skeleton
				instVarAt: index
				put: (aMaVariableObjectBuffer maInstVarAt: index) ].
	^ skeleton! !

!Object class methodsFor: '*ma object serialization' stamp: 'cmm 11/23/2004 12:47'!
maMaterializeFrom: aMaByteObjectBuffer using: aMaObjectSerializer
	"This is the standard-case for building a skeleton of a variable-byte-sized object."
	^ aMaByteObjectBuffer asByteObject: self! !

!Object methodsFor: '*ma object serialization' stamp: ''!
maAsStorageObject
	"Some objects should be converted to another object before being stored
	in a buffer."

	^self
! !

!Object methodsFor: '*ma object serialization' stamp: 'cmm 12/1/2004 22:55'!
maBufferInstSize
	"Answer the number of pointers to other objects I logically have (which can be fewer than the number of physical pointers due to implementation of extra growth-space)."
	^ self maInstSize! !

!Object methodsFor: '*ma object serialization' stamp: 'cmm 12/2/2004 17:06'!
maEstablishPointerReferencesUsing: aMaObjectSerializer
	"I am currently loaded with oids of the objects that I should be referencing.  Now that objects for these oids are, themselves, materialized, I can now replace my referernces to oids wtih references to the real objects."
	self class isBytes ifTrue: [ "don't need to do this." ^ self ].
	1
		to: self maInstSize
		do:
			[ : instVarIndex | | oid |
			oid _ self instVarAt: instVarIndex.
			oid ifNotNil: "could be nil if different class def"
				[ "we shouldn't need to worry about transient vars here because they would have been stored as nil."
				self
					instVarAt: instVarIndex
	
				put: (
	
					aMaObjectSerializer
	
						objectWithOid: oid
	
						ifAbsent: [ aMaObjectSerializer proxyFor: oid ]) ] ]! !

!Object methodsFor: '*ma object serialization' stamp: ''!
maIsBufferedObjectProxy

	^false
! !

!Object methodsFor: '*ma object serialization' stamp: ''!
maIsHashedCollection

	^false
! !

!Object methodsFor: '*ma object serialization' stamp: 'cmm 12/2/2004 15:20'!
maIsTransient: varIndex
	"Answers whether my object referenced at varIndex should be serialized."
	
	varIndex = 0 "root object" ifTrue: [ ^ false ].
	self maTransientVariables isEmpty ifTrue: [ ^ false ].
	^ self maTransientVariables includes: (self class maAllInstVarNamesAt: varIndex)! !

!Object methodsFor: '*ma object serialization' stamp: 'cmm 12/1/2004 17:37'!
maRequiresOwnBuffer
	"Answers false if the receiver has a special oid to represent it, such as nil, true, false and other immutables do."

	^ self class maInstancesRequireOwnBuffer! !

!Object methodsFor: '*ma object serialization' stamp: 'cmm 11/21/2004 22:40'!
maSelectPreMadeObjectBufferFrom: aMaObjectSerializer

	| cl |
	cl _ self class.
	cl isBytes ifTrue: [ ^ aMaObjectSerializer preMadeByteObjectBuffer ].
	self isBehavior ifTrue: [ ^ aMaObjectSerializer preMadeClassObjectBuffer ].
	(cl isWords and: [ cl isPointers not ]) ifTrue: [ ^ aMaObjectSerializer preMadeVariableWordBuffer ].
	cl maIsLogicallyVariable ifTrue: [ ^ aMaObjectSerializer preMadeVariableObjectBuffer ].
	^ aMaObjectSerializer preMadeFixedObjectBuffer! !

!Object methodsFor: '*ma object serialization' stamp: 'cmm 10/15/2004 12:28'!
maSerializationClass
	"All objects that can be serialized by Ma object serialization have their classes recorded mapped to an id except for Classes instances.  The class for these objects maps directly to Metaclass, rather than their specific metaclass instance."

	^ self class! !

!Object methodsFor: '*ma object serialization' stamp: 'cmm 12/2/2004 14:23'!
maShouldAppendWithPath: path parent: parent index: indexInteger
	^ parent isNil
	or:
		[ self maRequiresOwnBuffer
		and: [ (parent maIsTransient: indexInteger) not ] ]! !

!Object methodsFor: '*ma object serialization' stamp: 'cmm 12/2/2004 14:20'!
maShouldTraverseWithPath: path parent: parent index: indexInteger
	| cl |
	cl _ self class.
	cl isBytes ifTrue: [ ^ false ].
	(cl isVariable and: [ cl isPointers not ]) ifTrue: [ ^ false ].
	^ self maUsesStandardStorage
	and: [ (parent maIsTransient: indexInteger) not ]! !

!Object methodsFor: '*ma object serialization' stamp: 'cmm 12/1/2004 22:56'!
maSizeIn: aMaObjectBuffer
	"Answer the size of the buffer that contains the object references, excluding the header."

	^ self maBufferInstSize * aMaObjectBuffer slotSize! !

!Object methodsFor: '*ma object serialization' stamp: 'cmm 12/2/2004 17:07'!
maStreamVariablyInto: aMaVariableBuffer for: aMaObjectSerializer
	"Put the receivers instance variables (both named and indexed) into aMaVariableObjectBuffer."

	1
		to: self maInstSize
		do:
			[ : index |
			(index > self class instSize or: [ (self maIsTransient: index) not ])
				ifTrue:
					[ aMaVariableBuffer
						maInstVarAt: index
						put: (aMaObjectSerializer oidFor: (self instVarAt: index)) ] ]! !

!Object methodsFor: '*ma object serialization' stamp: 'cmm 11/29/2004 17:05'!
maTransientVariables
	^ #()! !

!Object methodsFor: '*ma object serialization' stamp: 'cmm 11/29/2004 11:01'!
maUsesStandardStorage

	^ true! !

!Object methodsFor: '*ma object serialization' stamp: 'cmm 11/26/2004 13:08'!
maWantsPostMaterialization
	"Most objects do not need any preserialization behavior, therefore this allows the serializer to avoid the overhead of withAllSuperclassesDo:."
	^ false! !

!Object methodsFor: '*ma object serialization' stamp: 'cmm 11/26/2004 13:08'!
maWantsPreSerialization
	"Most objects do not need any preserialization behavior, therefore this allows the serializer to avoid the overhead of withAllSuperclassesDo:."
	^ false! !

!Float class methodsFor: '*ma object serialization' stamp: 'cmm 6/11/2004 13:57'!
maInstancesRequireOwnBuffer

	^ false! !

!Float methodsFor: '*ma object serialization' stamp: 'cmm 8/8/2002 23:05'!
maOid

	^MaOidCalculator oidForFloat: self! !

!Color methodsFor: '*ma object serialization' stamp: 'cmm 11/26/2004 13:12'!
maWantsPreSerialization 
	^ true! !

MaMutatingProxy subclass: #MaBufferedObjectProxy
	instanceVariableNames: 'oid'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma object serialization-private'!

!MaBufferedObjectProxy class methodsFor: 'creation' stamp: ''!
oid: anInteger

	^self new oid: anInteger
! !

!MaBufferedObjectProxy methodsFor: 'testing' stamp: ''!
maIsBufferedObjectProxy

	^true
! !

!MaBufferedObjectProxy methodsFor: 'testing' stamp: ''!
maRequiresOwnBuffer

	^false
! !

!MaBufferedObjectProxy methodsFor: 'testing' stamp: ''!
oid

	^oid
! !

!MaBufferedObjectProxy methodsFor: 'private building' stamp: ''!
oid: anInteger

	oid _ anInteger
! !

!Dictionary class methodsFor: '*ma object serialization' stamp: 'cmm 12/2/2004 12:35'!
maLoadVariableObjectFrom: aMaVariableObjectBuffer
	| skeleton |
	skeleton _ self new: aMaVariableObjectBuffer objectInstSize / 2. "key + value"
	1
		to: aMaVariableObjectBuffer objectInstSize
		by: 2
		do:
			[ :index |
			skeleton
				at: (aMaVariableObjectBuffer maInstVarAt: index)
				put: (aMaVariableObjectBuffer maInstVarAt: index + 1) ].
	^ skeleton! !

!Dictionary methodsFor: '*ma object serialization' stamp: 'cmm 12/1/2004 22:55'!
maBufferInstSize

	^ self size * 2! !

!Dictionary methodsFor: '*ma object serialization' stamp: 'cmm 11/23/2004 10:27'!
maEstablishPointerReferencesUsing: aMaObjectSerializer

	| transformer fullOfOidsCopy |
	self isEmpty ifTrue: [ ^ self ]. "performance"
	transformer _
		[ :object |
			(aMaObjectSerializer
				objectWithOid: object
				ifAbsent: [ aMaObjectSerializer proxyFor: object ]) ].
	fullOfOidsCopy _ self copy.
	self maRemoveAll.
	fullOfOidsCopy keysAndValuesDo:
		[ :eachKey :eachValue |
		self
			at: (transformer value: eachKey)
			put: (transformer value: eachValue) ]! !

!Dictionary methodsFor: '*ma object serialization' stamp: ''!
maIsHashedCollection

	^true
! !

!Dictionary methodsFor: '*ma object serialization' stamp: 'cmm 11/28/2004 16:20'!
maStreamVariablyInto: aMaVariableObjectBuffer for: aMaObjectSerializer
	"Put the receivers instance variables into aMaVariableObjectBuffer."

	| index |
	index _ 1.
	self keysAndValuesDo:
		[ : eachKey : eachValue |
		[ : obj |
			aMaVariableObjectBuffer
				maInstVarAt: index
				put: (aMaObjectSerializer oidFor: obj).
			index _ index + 1 ]
				value: eachKey;
				value: eachValue ].
	"Now take care of additional named variables."
	3 "skip array and tally, they're taken care of logically, above."
		to: self maInstSize
		do:
			[ : namedIndex |
			aMaVariableObjectBuffer
				maInstVarAt: index + namedIndex
				put: (aMaObjectSerializer oidFor: (self instVarAt: namedIndex)) ]! !

MaSoftwareError subclass: #MaObjectSerializationSoftwareError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma object serialization-exceptions'!

!ColorForm methodsFor: '*ma object serialization' stamp: 'cmm 11/26/2004 14:34'!
maWantsPreSerialization
	^ true! !

!PasteUpMorph class methodsFor: '*ma object serialization' stamp: 'cmm 11/23/2004 12:52'!
maMaterializeFrom: aMaByteObjectBuffer using: aMaObjectSerializer

	^ World! !

!Bitmap class methodsFor: '*ma object serialization' stamp: 'cmm 11/23/2004 12:37'!
maMaterializeFrom: aMaByteObjectBuffer using: aMaObjectSerializer

	^ self decompressFromByteArray: aMaByteObjectBuffer asByteArray! !

!Bitmap methodsFor: '*ma object serialization' stamp: 'cmm 11/7/2004 22:54'!
maAsStorageObject

	^ self compressToByteArray! !

!Bitmap methodsFor: '*ma object serialization' stamp: 'cmm 11/29/2004 11:00'!
maUsesStandardStorage

	^ false! !

!Boolean class methodsFor: '*ma object serialization' stamp: 'cmm 6/11/2004 13:57'!
maInstancesRequireOwnBuffer

	^ false! !

!MaMinimalObject methodsFor: '*ma object serialization' stamp: ''!
maIsBufferedObjectProxy

	^false
! !

MaWarning subclass: #MaObjectSerializationWarning
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma object serialization-exceptions'!

!Symbol class methodsFor: '*ma object serialization' stamp: 'cmm 11/23/2004 12:47'!
maMaterializeFrom: aMaByteObjectBuffer using: aMaObjectSerializer
	"This is the standard-case for building a skeleton of a variable-byte-sized object."
	^ aMaByteObjectBuffer asString asSymbol! !

!CompiledMethod class methodsFor: '*ma object serialization' stamp: 'cmm 11/15/2004 15:21'!
maMaterializeFrom: aMaByteObjectBuffer using: aMaObjectSerializer

	^ (aMaObjectSerializer copyWithNewOidSpace materializeGraph: aMaByteObjectBuffer asByteArray) asCompiledMethod! !

!CompiledMethod methodsFor: '*ma object serialization' stamp: 'cmm 11/12/2004 10:54'!
maAsStorageObject

	^ MaCompiledMethodStorage newFor: self! !

!CompiledMethod methodsFor: '*ma object serialization' stamp: 'cmm 11/29/2004 11:01'!
maUsesStandardStorage

	^ false! !

!Class class methodsFor: '*ma object serialization' stamp: 'cmm 10/28/2004 22:29'!
maMaterializeFrom: aMaClassReferenceBuffer using: aMaObjectSerializer

	^ (aMaObjectSerializer classIdManager 
		classDefinitionsForId: aMaClassReferenceBuffer representedClassId) last

		ensureClassUsing: aMaObjectSerializer! !

!Class methodsFor: '*ma object serialization' stamp: 'cmm 10/27/2004 22:53'!
maSerializationClass

	^ Class! !

!Class methodsFor: '*ma object serialization' stamp: 'cmm 11/29/2004 11:01'!
maUsesStandardStorage

	^ false! !

MaSecurityViolation subclass: #MaObjectSerializationSecurityViolation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma object serialization-exceptions'!

!ViewerFlapTab methodsFor: '*ma object serialization' stamp: 'cmm 11/26/2004 14:34'!
maWantsPostMaterialization 
	^ true! !

!ViewerFlapTab methodsFor: '*ma object serialization' stamp: 'cmm 11/26/2004 14:33'!
maWantsPreSerialization
	^ true! !

!LargePositiveInteger class methodsFor: '*ma object serialization' stamp: 'cmm 12/1/2004 23:56'!
maMaterializeFrom: aMaByteObjectBuffer using: aMaObjectSerializer

	^ aMaByteObjectBuffer asByteObject: self! !

!LargePositiveInteger methodsFor: '*ma object serialization' stamp: 'cmm 12/1/2004 23:19'!
maAsStorageObject

	| answer |
	answer _ ByteArray new: self digitLength.
	1 to: self digitLength do:
		[ : x |
		answer at: x put: (self digitAt: x) ].
	^ answer! !

!LargePositiveInteger methodsFor: '*ma object serialization' stamp: 'cmm 11/29/2004 11:36'!
maUsesStandardStorage 
	^ false! !

!Behavior methodsFor: '*ma object serialization' stamp: 'cmm 12/2/2004 15:27'!
maAllInstVarNamesAt: anInteger

	| x |
	x _ 0.
	self maAllInstVarNamesDo:
		[ : each | 
		x _ x + 1.
		x = anInteger ifTrue: [ ^ each ] ].
	self error: 'Index out of bounds:  ', anInteger printString! !

!ContextPart methodsFor: '*ma object serialization' stamp: 'cmm 11/29/2004 11:01'!
maUsesStandardStorage

	^ false! !

!HandMorph class methodsFor: '*ma object serialization' stamp: 'cmm 11/23/2004 12:37'!
maMaterializeFrom: aMaByteObjectBuffer using: aMaObjectSerializer

	^ ActiveHand! !

!HandMorph methodsFor: '*ma object serialization' stamp: 'cmm 6/30/2004 13:58'!
maAsStorageObject
	"We don't yet support serialization of individual HandMorphs.  For now, we restore any HandMorph as a logical link to the ActiveHand."

	^ String maEmpty! !

!HandMorph methodsFor: '*ma object serialization' stamp: 'cmm 11/29/2004 11:01'!
maUsesStandardStorage

	^ false! !

!WeakSet methodsFor: '*ma object serialization' stamp: 'cmm 12/1/2004 22:55'!
maBufferInstSize

	^ self slowSize! !

!WeakSet methodsFor: '*ma object serialization' stamp: 'cmm 12/1/2004 22:57'!
maStreamVariablyInto: aMaVariableObjectBuffer for: aMaObjectSerializer
	"If a GC has happened since we set aMaVariableObjectBuffer's logicalSize then, upon materialization, it may try to load with 'garbage' oids because we load up to the number of logicalSize instVars (and the buffer would have garbage at those places).  Therefore, reset the logicalSize after populating."
	super
		maStreamVariablyInto: aMaVariableObjectBuffer
		for: aMaObjectSerializer.
	aMaVariableObjectBuffer physicalSize: (self maSizeIn: aMaVariableObjectBuffer)! !

!Exception methodsFor: '*ma object serialization' stamp: 'cmm 11/26/2004 13:13'!
maWantsPreSerialization 
	^ true! !

MaObject subclass: #MaBlockContextStorage
	instanceVariableNames: 'nargs startpc home'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma object serialization-private'!

!MaBlockContextStorage class methodsFor: 'as yet unclassified' stamp: 'cmm 11/9/2004 15:11'!
newFor: aBlockContext

	^ self new
		initializeFrom: aBlockContext ;
		yourself! !

!MaBlockContextStorage methodsFor: 'as yet unclassified' stamp: 'cmm 11/9/2004 15:07'!
asBlockContext

	| methodContext |
	methodContext _ home asMethodContext.
	^ (BlockContext newForMethod: methodContext method)
		home: methodContext
		startpc: startpc
		nargs: nargs! !

!MaBlockContextStorage methodsFor: 'as yet unclassified' stamp: 'cmm 11/9/2004 15:12'!
initializeFrom: aBlockContext

	nargs _ aBlockContext numArgs.
	startpc _ aBlockContext startpc.
	home _ MaMethodContextStorage newFor: aBlockContext home! !

MaObject subclass: #MaClassIdManager
	instanceVariableNames: 'classesById idsByClass nextClassId classDefinitionsById inImageDefinitions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma object serialization-support'!

MaClassIdManager class
	instanceVariableNames: 'MinimumClasses'!

!MaClassIdManager commentStamp: 'cmm 6/11/2004 16:53' prior: 0!
classDefinitionsById -- all versions of all classes that I know about
 inImageDefinitions -- the in-image version of each class I know about.!

!MaClassIdManager class methodsFor: 'accessing' stamp: 'cmm 10/27/2004 22:52'!
minimumClasses

	^ { Metaclass.  Class.
	MaClassDefinition.
	Boolean. SmallInteger. Character. Float. UndefinedObject.
	Array. Symbol. String. ByteArray. Set. OrderedCollection. Dictionary }! !

!MaClassIdManager methodsFor: 'building' stamp: 'cmm 10/29/2004 11:01'!
addClassDefinition: aMaClassDefinition

	| definitions answer |
	definitions _ self ensureClassDefinitionsFor: aMaClassDefinition.
	(answer _ self definitionLike: aMaClassDefinition in: definitions)
		ifNil:
			[ answer _ aMaClassDefinition.
			definitions add: aMaClassDefinition.
			aMaClassDefinition version: definitions size ].
	answer isDefined ifTrue:
		[ self
			idOfClass: answer classObject
			is: answer id.
		self refreshInImageDefinition: answer classObject.
		(answer superclassDefinition isNil and: [ answer classObject superclass ~= nil ])
			ifTrue:
				[ self addNewClass: answer classObject superclass.
				answer initializeSuperclassDefinitionUsing: self ] ].
	answer superclassDefinition notNil
		ifTrue:
			[ self addClassDefinition: answer superclassDefinition ].
	^ answer! !

!MaClassIdManager methodsFor: 'building' stamp: 'cmm 10/17/2004 22:38'!
addNewClass: aClass
	"Answer the storage definition created for aClass."

	aClass isMeta ifTrue: [ MaObjectSerializationSoftwareError signal: 'Metaclass instances are not stored here.' ].
	^ self addClassDefinition: (MaClassDefinition className: aClass name)! !

!MaClassIdManager methodsFor: 'accessing' stamp: ''!
classDefinitionsById

	^classDefinitionsById
! !

!MaClassIdManager methodsFor: 'building' stamp: 'cmm 6/29/2004 17:42'!
classDefinitionsById: aDictionary

	classDefinitionsById _ aDictionary! !

!MaClassIdManager methodsFor: 'accessing' stamp: 'cmm 10/17/2004 22:39'!
classDefinitionsForClass: aClass

	aClass isMeta ifTrue: [ MaObjectSerializationSoftwareError signal: 'Metaclass instances are not stored here.' ].
	^ self classDefinitionsForId: (self idForClass: aClass)! !

!MaClassIdManager methodsFor: 'accessing' stamp: 'cmm 10/12/2004 22:15'!
classDefinitionsForId: anInteger

	^ self
		classDefinitionsForId: anInteger
		ifAbsent: [ MagmaSoftwareError signal: 'class-definition not found' ]! !

!MaClassIdManager methodsFor: 'accessing' stamp: 'cmm 10/12/2004 22:16'!
classDefinitionsForId: anInteger ifAbsent: aBlock

	^ anInteger
		ifNil: [ aBlock value ]
		ifNotNil:
			[ classDefinitionsById
				at: anInteger
				ifAbsent: aBlock ]! !

!MaClassIdManager methodsFor: 'accessing' stamp: 'cmm 6/8/2004 16:13'!
classForId: anInteger

	^ self
		classForId: anInteger
		ifAbsent: [ self error: anInteger printString, ' is not a known class id.' ]! !

!MaClassIdManager methodsFor: 'accessing' stamp: 'cmm 6/22/2004 12:52'!
classForId: anInteger ifAbsent: aBlock

	^ anInteger <= self minimumClasses size
		ifTrue:
			[ self minimumClasses at: anInteger ]
		ifFalse:
			[ classesById
				at: anInteger
				ifAbsent: aBlock ]! !

!MaClassIdManager methodsFor: 'accessing' stamp: 'cmm 10/17/2004 22:39'!
currentVersionOfClass: aClass

	aClass isMeta ifTrue: [ MaObjectSerializationSoftwareError signal: 'Metaclass instances are not stored here.' ].
	^ (self
		inImageDefinition: aClass
		ifAbsent: [ ^ 1 ]) version! !

!MaClassIdManager methodsFor: 'accessing' stamp: 'cmm 6/21/2004 13:22'!
definitionForClassId: classIdInteger version: classVersionInteger

	^ classVersionInteger = 0
		ifTrue: [ self inImageDefinition: (self classForId: classIdInteger) ]
		ifFalse: [ (self classDefinitionsById at: classIdInteger) at: classVersionInteger ]! !

!MaClassIdManager methodsFor: 'testing' stamp: 'cmm 10/13/2004 23:43'!
definitionLike: aMaClassDefinition in: definitionsCollection

	definitionsCollection isEmpty ifTrue: [ ^ nil ].
	(definitionsCollection anySatisfy: [ : each | each className = aMaClassDefinition className ]) ifFalse: [ ^ nil ].
	(definitionsCollection includes: aMaClassDefinition) ifTrue: [ ^ aMaClassDefinition ].
	^ definitionsCollection 
		detect: [ : eachDef | eachDef hasSameDefinitionAs: aMaClassDefinition ]
		ifNone: [ nil ]! !

!MaClassIdManager methodsFor: 'accessing' stamp: 'cmm 10/14/2004 09:42'!
ensureClassDefinitionsFor: aMaClassDefinition
	"Look for the collection of versions of the same class that aMaClassDefinition is for.  If none exist create and answer the new collection that will hold aMaClassDefinition and its future versions."

	^ (aMaClassDefinition id notNil and: [ classDefinitionsById includesKey: aMaClassDefinition id ])
		ifTrue: [ classDefinitionsById at: aMaClassDefinition id ]
		ifFalse:
			[ classDefinitionsById 
				maDetect: [ : eachDefinitions | eachDefinitions anySatisfy: [ : each | each isKnownAs: aMaClassDefinition className ] ]
				ifFound:
					[ : foundDefinitions | 
					aMaClassDefinition id: foundDefinitions first id.
					foundDefinitions ]
				ifNone:
					[ "None found, let's create one."
					| id class |
					"First figure out the id."
					id _ aMaClassDefinition hasId
						ifTrue: [ aMaClassDefinition id ]
						ifFalse:
							[ "Make sure not one of the minimumClasses."
							((Smalltalk hasClassNamed: aMaClassDefinition className) and: [ self isMemberOfMinimumClasses: (class _ Smalltalk at: aMaClassDefinition className) ])
								ifTrue: [ self idForClass: class ]
								ifFalse: [ self nextClassId ] ].
					aMaClassDefinition id: id.
					classDefinitionsById
						at: id
						put: (OrderedCollection new: 1) ] ]! !

!MaClassIdManager methodsFor: 'event handling' stamp: 'cmm 10/1/2004 15:21'!
handleClassModification: aClass using: aMaObjectSerializer

	"Optional subclass hook."! !

!MaClassIdManager methodsFor: 'testing' stamp: 'cmm 10/15/2004 12:31'!
hasClassDefinitionFor: aClass

	| foundQuickly |
	foundQuickly _ inImageDefinitions
		maAt: aClass
		ifPresent: [ : definition | definition isPartOfClassDefinitions ]
		ifAbsent: [ false ].
	^ foundQuickly or:
		[ classDefinitionsById anySatisfy:
			[ : eachDefinitions |
			(eachDefinitions last isKnownAs: aClass name)
			and: [ eachDefinitions
				anySatisfy:
					[ : each | each hasSameDefinitionAs: aClass ] ] ] ]! !

!MaClassIdManager methodsFor: 'accessing' stamp: 'cmm 8/26/2002 22:03'!
idForClass: aClass

	^self
		idForClass: aClass
		ifAbsent: [ MaSoftwareError signal: aClass name, ' has no id assigned.' ]! !

!MaClassIdManager methodsFor: 'accessing' stamp: 'cmm 10/17/2004 22:39'!
idForClass: aClass ifAbsent: aBlock

	| index |
	aClass isMeta ifTrue: [ MaObjectSerializationSoftwareError signal: 'Metaclass instances are not stored here.' ].
	^ idsByClass
		at: aClass
		ifAbsent: 
			[ 
(index _ self minimumClasses indexOf: aClass) > 0
				ifTrue: [ index ]
				ifFalse: [ aBlock value ] ]! !

!MaClassIdManager methodsFor: 'building' stamp: 'cmm 10/15/2004 12:06'!
idOfClass: aClass is: anInteger

	nextClassId _ nextClassId max: anInteger.
	classesById
		at: anInteger
		put: aClass.
	^idsByClass
		at: aClass
		put: anInteger
! !

!MaClassIdManager methodsFor: 'accessing' stamp: 'cmm 6/6/2004 19:46'!
inImageDefinition: aClass

	^ self
		inImageDefinition: aClass
		ifAbsent: [ self error: aClass name, ' is not part of my inImageDefinitions.' ]! !

!MaClassIdManager methodsFor: 'accessing' stamp: 'cmm 10/15/2004 11:58'!
inImageDefinition: aClass ifAbsent: aBlock

	^ inImageDefinitions
		at: (aClass isMeta ifTrue: [ Metaclass ] ifFalse: [ aClass ])
		ifAbsent: aBlock! !

!MaClassIdManager methodsFor: 'accessing' stamp: 'cmm 6/5/2004 14:09'!
inImageDefinitionNamed: aSymbol

	^ inImageDefinitions detect: [ : each | each className = aSymbol ]! !

!MaClassIdManager methodsFor: 'testing' stamp: 'cmm 6/30/2004 00:03'!
includesIdForClass: aClass

	^ idsByClass includesKey: aClass! !

!MaClassIdManager methodsFor: 'creation' stamp: 'cmm 6/16/2004 15:39'!
independentCopy

	^self copyWithAttributes: #('classesById' 'idsByClass' 'classDefinitionsById' 'inImageDefinitions')! !

!MaClassIdManager methodsFor: 'private' stamp: 'cmm 6/29/2004 17:47'!
initialize

	super initialize.
	idsByClass _ Dictionary new.
	classesById _ Dictionary new.
	nextClassId _ 100.
	inImageDefinitions _ Dictionary new.
	self classDefinitionsById: Dictionary new.
	self initializeMinimumClasses! !

!MaClassIdManager methodsFor: 'private' stamp: 'cmm 6/11/2004 16:56'!
initializeMinimumClasses

	self minimumClasses do: [ : each | self addNewClass: each ]! !

!MaClassIdManager methodsFor: 'testing' stamp: 'cmm 10/17/2004 22:39'!
isMemberOfMinimumClasses: aClass
	aClass isMeta ifTrue: [ MaObjectSerializationSoftwareError signal: 'Metaclass instances are not stored here.' ].
	^ self minimumClasses includes: aClass! !

!MaClassIdManager methodsFor: 'accessing' stamp: ''!
minimumClasses

	^self class minimumClasses
! !

!MaClassIdManager methodsFor: 'private' stamp: 'cmm 8/15/2002 23:53'!
nextClassId

	^nextClassId _ nextClassId + 1
! !

!MaClassIdManager methodsFor: 'accessing' stamp: 'cmm 3/26/2003 23:21'!
numberOfClasses

	^classesById size
! !

!MaClassIdManager methodsFor: 'building' stamp: 'cmm 10/29/2004 11:00'!
refreshInImageDefinition: aClass
	"Whenever the user recompiles a class in the image (e.g., during development)."

	({ Object. ProtoObject } includes: aClass) ifTrue: [ ^ self ]. "performance"
	aClass withAllSubclassesDo:
		[ : eachClass |  	| knownDefinitions |
		(eachClass = aClass or: [ self includesIdForClass: eachClass ])
			ifTrue:
				[ knownDefinitions _ (self hasClassDefinitionFor: eachClass)
					ifTrue: [ self classDefinitionsForClass: eachClass ]
					ifFalse: [ #() ].
				inImageDefinitions
					at: eachClass
					put:
						(knownDefinitions
							maDetect: [ : each | each hasSameDefinitionAs: eachClass ]
							ifFound:
								[ : foundDef |
								"In the rare case, where a classdef was materialized but not defined in the image, so it was added to definitions only.  Now we're defining it so we need to be sure we set up its mappings."
								self
									idOfClass: eachClass
									is: foundDef id.
								foundDef ]
							ifNone: [ MaClassDefinition className: eachClass name ]) ] ]! !

MaObject subclass: #MaCompiledMethodStorage
	instanceVariableNames: 'header literals startPc endPc byteCodes sourcePointer selector className'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma object serialization-private'!

!MaCompiledMethodStorage class methodsFor: 'as yet unclassified' stamp: 'cmm 11/9/2004 15:12'!
newFor: aCompiledMethod

	^ self new
		initializeFrom: aCompiledMethod ;
		yourself! !

!MaCompiledMethodStorage methodsFor: 'as yet unclassified' stamp: 'cmm 11/25/2004 23:34'!
asCompiledMethod

	| answer |
	answer _ 
		CompiledMethod 
			newMethod: endPc - startPc + 1 + 4
			header: header.
	literals withIndexDo: 
		[ : each : index |
		answer
			literalAt: index
			put: each ].
"	answer setSourcePointer: sourcePointer."  "<-- don't restore it, it could be wrong."
"In fact..."
sourcePointer > 0 ifTrue: [ answer zapSourcePointer ].
	answer
		replaceFrom: startPc
		to: endPc
		with: byteCodes
		startingAt: 1.
	self restoreLiterals: answer.
	^ answer! !

!MaCompiledMethodStorage methodsFor: 'as yet unclassified' stamp: 'cmm 11/14/2004 20:25'!
cleanLiterals: aCompiledMethod
	"Strip class-var objects from anArray (nil them out).  Class vars are not stored, but we will try to hook them up by name upon materialization."
	| answer |
	answer _ aCompiledMethod literals.
	answer withIndexDo:
		[ : eachLiteral : index |
		(eachLiteral isVariableBinding
		and: [ eachLiteral isSpecialWriteBinding not ])
			ifTrue:
				[ answer at: index put: eachLiteral copy.
				"nil out the global object, we will remap to it by name upon materialization (see restoreLiterals:)."
				(answer at: index) value: nil ] ].
	^ answer! !

!MaCompiledMethodStorage methodsFor: 'as yet unclassified' stamp: 'cmm 11/14/2004 19:12'!
initializeFrom: aCompiledMethod

	className _ aCompiledMethod maMethodClass name.
	selector _ aCompiledMethod selector.
	literals _ self cleanLiterals: aCompiledMethod.
	header _ aCompiledMethod header.
	sourcePointer _ aCompiledMethod sourcePointer.
	startPc _ aCompiledMethod initialPC.
	endPc _ aCompiledMethod endPC.
	byteCodes _ ByteArray new: endPc - startPc + 1.
	byteCodes
		replaceFrom: 1
		to: byteCodes size
		with: aCompiledMethod
		startingAt: startPc! !

!MaCompiledMethodStorage methodsFor: 'as yet unclassified' stamp: 'cmm 11/14/2004 20:37'!
restoreLiterals: aCompiledMethod
	"This method attempts to logically restore any reference to class-vars in aCompiledMethod.  Even though aCompiledMethod is not installed in the system, I saved its class and selector during serialization, now I can use that information to, if present, re-hook up the class variable up to the one in this image." 
	aCompiledMethod literals withIndexDo:
		[ : eachLiteral : index |
		(eachLiteral isVariableBinding
		and: [ eachLiteral isSpecialWriteBinding not ])
			ifTrue:
				[ | methodClass classVarNames globalObject |
				methodClass _ Smalltalk at: className ifAbsent: [ nil ].
				globalObject _ (methodClass notNil and: [ methodClass classVarNames includes: eachLiteral key ])
					ifTrue: [ methodClass classPool at: eachLiteral key ]
					ifFalse:
						[ "Ok, not a class-var (at least not any more), check to see if its a Smalltalk global."
						Smalltalk
							at: eachLiteral key
							ifAbsent:
								[ ^ MaObjectSerializationWarning signal: 'Warning, cannot remap ', className, '>>''', eachLiteral key, ''' because that global is no longer defined.' ] ].
				aCompiledMethod
					literalAt: index
					put: className->globalObject ] ]! !

MaObject subclass: #MaGlobalReference
	instanceVariableNames: 'globalName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma object serialization-support'!

MaGlobalReference subclass: #MaClassReference
	instanceVariableNames: 'id'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma object serialization-support'!

MaClassReference subclass: #MaClassDefinition
	instanceVariableNames: 'instVarNames version superclassDefinition category type comment commentStamp classVarNames poolDictionaryNames classInstVarNames aliases'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma object serialization-support'!

!MaClassDefinition class methodsFor: 'creation' stamp: 'cmm 6/16/2004 11:26'!
className: aSymbol

	^(super className: aSymbol)
		initializeFrom: (Smalltalk classNamed: aSymbol) ;
		yourself! !

!MaClassDefinition methodsFor: 'building' stamp: 'cmm 10/13/2004 23:49'!
addAlias: aSymbol
	"When my class is renamed, my old name beccomes one of my aliases.  This is necessary to accomodate further changes to my definition in clients that have not yet compiled the renamed version of me."

	aliases add: aSymbol! !

!MaClassDefinition methodsFor: 'accessing' stamp: 'cmm 12/19/2002 21:45'!
allInstVarNames
	^instVarNames! !

!MaClassDefinition methodsFor: 'private' stamp: 'cmm 5/18/2004 00:38'!
classInstanceVariablesString
	^ self stringForVariables: classInstVarNames! !

!MaClassDefinition methodsFor: 'building' stamp: 'cmm 10/13/2004 23:52'!
className: newClassName

	self className ifNotNil: [ aliases add: self className ].
	super className: newClassName! !

!MaClassDefinition methodsFor: 'private' stamp: 'cmm 5/18/2004 00:37'!
classVariablesString
	^ self stringForVariables: classVarNames! !

!MaClassDefinition methodsFor: 'actions' stamp: 'cmm 7/2/2004 00:09'!
createClassUsing: aMaObjectSerializer
	| superClass |
	superClass _
		Smalltalk at: self superclassName
		ifAbsent: [ (aMaObjectSerializer classIdManager inImageDefinitionNamed: self  superclassName) createClassUsing: aMaObjectSerializer ].
	^ SystemChangeNotifier uniqueInstance doSilently:
		[ ((ClassBuilder new)
			name: self className
			inEnvironment: superClass environment 
			subclassOf: superClass
			type: type 
			instanceVariableNames: self instanceVariablesString 
			classVariableNames: self classVariablesString 
			poolDictionaries: self sharedPoolsString
			category: category)
			
			ifNotNilDo:
				[ : class |
				aMaObjectSerializer classIdManager
					idOfClass: class
					is: self id.
				class class instanceVariableNames: self classInstanceVariablesString.
				class hasComment
					ifTrue: 
						[ class 
							classComment: comment 
							stamp: commentStamp ].
				class ] ]! !

!MaClassDefinition methodsFor: 'accessing' stamp: 'cmm 10/27/2004 23:34'!
ensureClassUsing: aMaObjectSerializer

	^ self isDefined
		ifTrue: [ self classObject ]
		ifFalse: [ self createClassUsing: aMaObjectSerializer ]! !

!MaClassDefinition methodsFor: 'testing' stamp: 'cmm 10/13/2004 16:44'!
hasSameDefinitionAs: aClassOrMaClassDefinition

	^ self allInstVarNames maMatchesElementsOf: aClassOrMaClassDefinition allInstVarNames! !

!MaClassDefinition methodsFor: 'converting' stamp: 'cmm 6/16/2004 22:40'!
indexOfInstVarCorrespondingTo: instVarIndex of: anotherMaClassDefinition
	"Answer the index of the instVar in me that corresponds to the one at instVarIndex in anotherMaClassDefinition."

	self == anotherMaClassDefinition ifTrue: [ ^ instVarIndex ].
	"different versions, determine if instVarIndex refers to a named or indexed var"
	^ instVarIndex > anotherMaClassDefinition allInstVarNames size
		ifTrue:
			[ "indexed inst var" 
			self allInstVarNames size + (instVarIndex - anotherMaClassDefinition allInstVarNames size) ]
		ifFalse:
			[ "find the instVar with the same name."
			self allInstVarNames
				indexOf: (anotherMaClassDefinition allInstVarNames at: instVarIndex) ]! !

!MaClassDefinition methodsFor: 'private' stamp: 'cmm 10/13/2004 23:50'!
initialize

	super initialize.
	self version: 0.
	aliases _ OrderedCollection new! !

!MaClassDefinition methodsFor: 'private' stamp: 'cmm 6/10/2004 23:43'!
initializeFrom: aClass

	self globalName: aClass name.
	instVarNames _ aClass allInstVarNames.
	classVarNames _ aClass classVarNames.
	poolDictionaryNames _ aClass poolDictionaryNames.
	classInstVarNames _ aClass class instVarNames.
	category _ aClass category.
	type _ aClass typeOfClass.
	comment _ aClass organization classComment asString.
	commentStamp _ aClass organization commentStamp! !

!MaClassDefinition methodsFor: 'building' stamp: 'cmm 6/11/2004 00:33'!
initializeSuperclassDefinitionUsing: aMaClassIdManager

	| superclassDefinitions |
	superclassDefinitions _ aMaClassIdManager classDefinitionsForClass: self classObject superclass.
	superclassDefinition _
		superclassDefinitions
			detect: [ : each | each hasSameDefinitionAs: self classObject superclass ]
			ifNone: [ aMaClassIdManager inImageDefinition: self classObject superclass ]! !

!MaClassDefinition methodsFor: 'private' stamp: 'cmm 10/13/2004 13:03'!
instanceVariablesString

	^ self stringForVariables: (instVarNames copyWithoutAll: superclassDefinition allInstVarNames)! !

!MaClassDefinition methodsFor: 'testing' stamp: 'cmm 6/8/2004 15:58'!
isDefined

	^ Smalltalk hasClassNamed: self className! !

!MaClassDefinition methodsFor: 'testing' stamp: 'cmm 10/13/2004 23:53'!
isKnownAs: className

	^ self name = className
	or: [ aliases includes: className ]! !

!MaClassDefinition methodsFor: 'testing' stamp: 'cmm 6/7/2004 21:35'!
isPartOfClassDefinitions

	^ version > 0! !

!MaClassDefinition methodsFor: 'converting' stamp: 'cmm 1/20/2003 00:49'!
maAsStorageObject

	^self! !

!MaClassDefinition methodsFor: 'printing' stamp: 'cmm 6/24/2004 14:42'!
maPrintAbbreviatedOn: aStream

	super maPrintAbbreviatedOn: aStream.
	self
		maPrintAttribute: #version
		on: aStream! !

!MaClassDefinition methodsFor: 'testing' stamp: 'cmm 11/26/2004 15:12'!
maWantsPostMaterialization
	^ true! !

!MaClassDefinition methodsFor: 'accessing' stamp: 'cmm 12/19/2002 21:43'!
namedInstSize
	^self allInstVarNames size! !

!MaClassDefinition methodsFor: 'testing' stamp: 'cmm 6/16/2004 14:48'!
representsClassInImage

	^ (Smalltalk hasClassNamed: self className)
	and: [ self hasSameDefinitionAs: self classObject ]! !

!MaClassDefinition methodsFor: 'private' stamp: 'cmm 5/18/2004 00:35'!
sharedPoolsString
	^ self stringForVariables: poolDictionaryNames! !

!MaClassDefinition methodsFor: 'private' stamp: 'cmm 5/18/2004 00:34'!
stringForVariables: aCollection

	^ String streamContents:
		[ :stream |
		aCollection
			do: [ :ea | stream nextPutAll: ea ]
			separatedBy: [ stream space ] ]! !

!MaClassDefinition methodsFor: 'accessing' stamp: 'cmm 6/11/2004 00:55'!
superclassDefinition

	^ superclassDefinition! !

!MaClassDefinition methodsFor: 'accessing' stamp: 'cmm 6/10/2004 23:49'!
superclassName

	^ superclassDefinition className! !

!MaClassDefinition methodsFor: 'accessing' stamp: ''!
version

	^version! !

!MaClassDefinition methodsFor: 'building' stamp: 'cmm 6/23/2004 13:49'!
version: anInteger

	version _ anInteger
! !

!MaClassDefinition methodsFor: 'actions' stamp: 'cmm 10/17/2004 15:04'!
withAllSuperclassDefinitionsDo: oneArgBlock
	"Value oneArgBlock with myself, then each of my superclass-definitions, in turn."

	oneArgBlock value: self.
	superclassDefinition ifNotNil: [ superclassDefinition withAllSuperclassDefinitionsDo: oneArgBlock ]! !

!MaClassReference class methodsFor: 'creation' stamp: 'cmm 6/28/2004 18:05'!
className: aSymbol

	^ self globalName: aSymbol! !

!MaClassReference methodsFor: 'accessing' stamp: ''!
className

	^self globalName
! !

!MaClassReference methodsFor: 'building' stamp: ''!
className: aSymbol

	self globalName: aSymbol
! !

!MaClassReference methodsFor: 'accessing' stamp: ''!
classObject

	^self globalObject
! !

!MaClassReference methodsFor: 'accessing' stamp: 'cmm 6/23/2004 00:03'!
hasId

	^ self id notNil! !

!MaClassReference methodsFor: 'accessing' stamp: ''!
id

	^id
! !

!MaClassReference methodsFor: 'building' stamp: ''!
id: anInteger

	id _ anInteger
! !

!MaClassReference methodsFor: 'converting' stamp: 'cmm 1/5/2003 16:19'!
maAsStorageObject
	"Some objects should be converted to another object before being stored
	in a buffer."

	^self name! !

!MaClassReference methodsFor: 'accessing' stamp: 'cmm 1/1/2003 23:52'!
name
	"For interface compatibility with Class."

	^self className! !

!MaGlobalReference class methodsFor: 'creation' stamp: ''!
globalName: aSymbol

	^self new globalName: aSymbol
! !

!MaGlobalReference methodsFor: 'private' stamp: ''!
globalName

	^globalName! !

!MaGlobalReference methodsFor: 'private' stamp: ''!
globalName: aSymbol

	globalName _ aSymbol
! !

!MaGlobalReference methodsFor: 'accessing' stamp: 'cmm 6/28/2004 14:29'!
globalObject

	^Smalltalk
		at: self globalName
		ifAbsent:
			[ MaObjectSerializationSoftwareError signal: self globalName, ' not defined in this image.'.
			self ]! !

!MaGlobalReference methodsFor: 'printing' stamp: 'cmm 4/22/2002 22:25'!
maPrintAbbreviatedOn: aStream

	aStream nextPutAll: self globalName
! !

MaObject subclass: #MaMethodContextStorage
	instanceVariableNames: 'method'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma object serialization-private'!

!MaMethodContextStorage class methodsFor: 'as yet unclassified' stamp: 'cmm 11/9/2004 15:11'!
newFor: aMethodContext

	^ self new
		initializeFrom: aMethodContext ;
		yourself! !

!MaMethodContextStorage methodsFor: 'as yet unclassified' stamp: 'cmm 11/12/2004 16:37'!
asMethodContext

	| cm |
	^ (MethodContext newForMethod: (cm _ method asCompiledMethod))
		privRefreshWith: cm ;
		yourself! !

!MaMethodContextStorage methodsFor: 'as yet unclassified' stamp: 'cmm 11/9/2004 15:14'!
initializeFrom: aMethodContext

	method _ MaCompiledMethodStorage newFor: aMethodContext method! !

MaObject subclass: #MaObjectBuffer
	instanceVariableNames: 'byteArray startPos'
	classVariableNames: 'BufferClasses'
	poolDictionaries: ''
	category: 'Ma object serialization-support'!

!MaObjectBuffer commentStamp: 'cmm 10/21/2004 12:41' prior: 0!
This class encapsulates a single object into its byteArray.  The 0-based buffer positions of my fields are:

	0 = oid (8 bytes)
	8 = physicalSize (3 bytes)
	11 = bufferType (1 byte)
	12 = classId (2 bytes)!

MaObjectBuffer subclass: #MaClassReferenceBuffer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma object serialization-support'!

!MaClassReferenceBuffer commentStamp: 'cmm 10/27/2004 22:22' prior: 0!
I represent a buffer that, when materializes, answers the class in the host Smalltalk image for the definition with my id.

	at position 14 is the representedClassId!

!MaClassReferenceBuffer methodsFor: 'accessing' stamp: 'cmm 10/27/2004 22:22'!
bufferPositionOfRepresentedClassId

	^ 14! !

!MaClassReferenceBuffer methodsFor: 'accessing' stamp: 'cmm 11/19/2004 15:31'!
bufferType
	^ 4! !

!MaClassReferenceBuffer methodsFor: 'creation' stamp: 'cmm 11/23/2004 12:53'!
createObjectUsing: aMaObjectSerializer
	^ (self ensureClassUsing: aMaObjectSerializer)
		maMaterializeFrom: self
		using: aMaObjectSerializer! !

!MaClassReferenceBuffer methodsFor: 'private' stamp: 'cmm 10/30/2004 16:31'!
physicalDataSizeNeededFor: anObject

	^ 0! !

!MaClassReferenceBuffer methodsFor: 'building' stamp: 'cmm 11/23/2004 10:56'!
populateBodyFor: storageObject using: aMaObjectSerializer
	"Class-reference buffers have no body."! !

!MaClassReferenceBuffer methodsFor: 'building' stamp: 'cmm 11/1/2004 12:28'!
populateHeaderFor: aBehavior storageObject: storageObject using: aMaObjectSerializer
	"physicalSize was already set in ensureSpaceFor:, no need to calculate it again."
	super
		populateHeaderFor: aBehavior
		storageObject: storageObject
		using: aMaObjectSerializer.
	self
		representedClassId: 
			(aMaObjectSerializer classIdManager
				idForClass: aBehavior theNonMetaClass
				ifAbsent: [ (aMaObjectSerializer classIdManager addNewClass: aBehavior theNonMetaClass) id ])! !

!MaClassReferenceBuffer methodsFor: 'accessing' stamp: 'cmm 10/27/2004 22:20'!
representedClassId

	^ self 
		uint: 16
		at: self bufferPositionOfRepresentedClassId! !

!MaClassReferenceBuffer methodsFor: 'accessing' stamp: 'cmm 10/27/2004 22:20'!
representedClassId: anInteger

	^ self 
		uint: 16
		at: self bufferPositionOfRepresentedClassId
		put: anInteger! !

MaObjectBuffer subclass: #MaFixedObjectBuffer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma object serialization-support'!

!MaFixedObjectBuffer commentStamp: 'cmm 10/21/2004 13:13' prior: 0!
This class encapsulates an object that has a fixed-size.  Most objects are fixed-sizevariable logical size, primarily Smalltalk collections including Byte-oriented collections such as ByteArray and String.

My 0-based buffer fields are:

	(see superclass)
	14 = classVersion (2 bytes)!

!MaFixedObjectBuffer methodsFor: 'accessing' stamp: 'cmm 10/21/2004 22:05'!
bufferPositionOfClassVersion
	"Zero-based position."

	^ 17! !

!MaFixedObjectBuffer methodsFor: 'accessing' stamp: 'cmm 11/19/2004 15:32'!
bufferType
	^ 3! !

!MaFixedObjectBuffer methodsFor: 'accessing' stamp: 'cmm 10/21/2004 22:05'!
classVersion

	^self 
		uint: 16
		at: self bufferPositionOfClassVersion
! !

!MaFixedObjectBuffer methodsFor: 'accessing' stamp: 'cmm 10/21/2004 22:05'!
classVersion: anInteger

	self
		uint: 16
		at: self bufferPositionOfClassVersion
		put: anInteger
! !

!MaFixedObjectBuffer methodsFor: 'creation' stamp: 'cmm 12/2/2004 12:35'!
createObjectUsing: aMaObjectSerializer
	| class skeleton indexedSize sourceDefinition inImageDefinition |
	class _ self ensureClassUsing: aMaObjectSerializer.
	sourceDefinition _ 
		aMaObjectSerializer classIdManager
			definitionForClassId: self classId
			version: self classVersion.
	inImageDefinition _ aMaObjectSerializer classIdManager inImageDefinition: class.
	indexedSize _ self objectInstSize - sourceDefinition namedInstSize.
	skeleton _ indexedSize = 0 ifTrue: [ class basicNew ] ifFalse: [ class basicNew: indexedSize ].
	self instVarsDoWithIndex:
		[ : eachOid : sourceIndex |  | targetIndex |
		targetIndex _
			inImageDefinition
				indexOfInstVarCorrespondingTo: sourceIndex
				of: sourceDefinition.
		targetIndex > 0 
			ifTrue:
				[ skeleton
					instVarAt: targetIndex
					put: eachOid ]
			ifFalse:
				[ eachOid = MaOidCalculator oidForNil
					ifFalse: 	[ aMaObjectSerializer recordTruncatedObject: skeleton ] ] ].
	^ skeleton! !

!MaFixedObjectBuffer methodsFor: 'building' stamp: 'cmm 11/22/2004 14:42'!
establishReferencesFrom: anObject using: aMaObjectSerializer

	1
		to: anObject maInstSize
		do:
			[ : instVarIndex | | oid |
			oid _ anObject instVarAt: instVarIndex.
			oid ifNotNil: "could be nil if different class def"
				[ anObject
	
				instVarAt: instVarIndex
	
				put: (
	
					aMaObjectSerializer
	
						objectWithOid: oid
	
						ifAbsent: [ aMaObjectSerializer proxyFor: oid ]) ] ]! !

!MaFixedObjectBuffer methodsFor: 'building' stamp: 'cmm 11/29/2004 16:56'!
populateBodyFor: storageObject using: aMaObjectSerializer
	1
		to: storageObject maInstSize
		do:
			[ :index |
			self
				maInstVarAt: index
				put:
					((storageObject maIsTransient: index)
						ifTrue: [ MaOidCalculator oidForNil ]
						ifFalse: [ aMaObjectSerializer oidFor: (storageObject instVarAt: index) ]) ]! !

!MaFixedObjectBuffer methodsFor: 'building' stamp: 'cmm 10/21/2004 23:18'!
populateHeaderFor: anObject storageObject: storageObject using: aMaObjectSerializer

	| classVersion |
	super
		populateHeaderFor: anObject
		storageObject: storageObject
		using: aMaObjectSerializer.
	classVersion _ 
		aMaObjectSerializer classIdManager
			currentVersionOfClass: (aMaObjectSerializer classFor: anObject).
	self classVersion: classVersion! !

!MaFixedObjectBuffer methodsFor: 'printing' stamp: 'cmm 12/1/2004 23:43'!
printOn: aStream

	super printOn: aStream.
	self
		maPrintAttributes: #(classVersion oids)
		on: aStream! !

!MaObjectBuffer class methodsFor: 'private accessing' stamp: 'cmm 1/27/2003 23:50'!
bufferClassFor: aByteArray startPos: anInteger

	^self bufferClasses at: 
		(aByteArray 
			maUint: 8
			at: anInteger + self bufferPositionOfBufferType)! !

!MaObjectBuffer class methodsFor: 'accessing' stamp: 'cmm 7/15/2002 23:04'!
bufferClasses

	^BufferClasses! !

!MaObjectBuffer class methodsFor: 'accessing' stamp: 'cmm 10/20/2004 22:14'!
bufferPositionOfBufferType

	^11! !

!MaObjectBuffer class methodsFor: 'private accessing' stamp: ''!
bufferPositionOfPhysicalSize
	"Zero-based logical position within this buffer's byteArray that contains the
	physical size of this buffer."

	^8
! !

!MaObjectBuffer class methodsFor: 'creation' stamp: 'cmm 7/10/2002 20:27'!
byteArray: aByteArray startPos: anInteger

	^self new
		startPos: anInteger;
		byteArray: aByteArray
! !

!MaObjectBuffer class methodsFor: 'creation' stamp: 'cmm 7/10/2002 20:28'!
createFromByteArray: aByteArray startPos: anInteger

	^(self
		bufferClassFor: aByteArray
		startPos: anInteger)
			byteArray: aByteArray
			startPos: anInteger
! !

!MaObjectBuffer class methodsFor: 'required overrides' stamp: 'cmm 10/21/2004 23:19'!
headerSize
	"The number of bytes in each object record before the data for the object begins."

	^ 24! !

!MaObjectBuffer class methodsFor: 'initializing' stamp: 'cmm 11/19/2004 15:13'!
initialize
	"Called from preamble of MaObjectSerialization."

	BufferClasses _ Array
		with: MaByteObjectBuffer
		with: MaVariableObjectBuffer
		with: MaFixedObjectBuffer
		with: MaClassReferenceBuffer
		with: MaVariableWordBuffer! !

!MaObjectBuffer methodsFor: 'converting' stamp: 'cmm 11/24/2004 11:16'!
asClonedObjectUsing: aMagmaSession

	| answer |
	answer _ (aMagmaSession
		objectWithOid: self oid
		ifAbsent: [ self error: 'should exist' ]) maShallowCopy.
	self
		refresh: answer
		using: aMagmaSession.
	^ answer! !

!MaObjectBuffer methodsFor: 'private' stamp: ''!
bufferPositionOfBufferType

	^self class bufferPositionOfBufferType
! !

!MaObjectBuffer methodsFor: 'accessing' stamp: 'cmm 10/21/2004 12:41'!
bufferPositionOfClassId
	"Zero-based position of the class id."

	^ 12! !

!MaObjectBuffer methodsFor: 'reference access' stamp: 'cmm 11/19/2004 15:52'!
bufferPositionOfInstVarAt: anInteger
	"Answer the physical 0-based byte-position within the receivers byteArray
	where the instVar with index anInteger is located."

	^ self headerSize + ((anInteger - 1) * self slotSize)! !

!MaObjectBuffer methodsFor: 'private' stamp: ''!
bufferPositionOfOid
	"Zero-based position within a buffer that the oid is at."

	^0
! !

!MaObjectBuffer methodsFor: 'private' stamp: ''!
bufferPositionOfPhysicalSize
	"Zero-based logical position within the byteArray that contains the
	physical size of this portion of the buffer (e.g., not including continuations)."

	^self class bufferPositionOfPhysicalSize
! !

!MaObjectBuffer methodsFor: 'private' stamp: 'cmm 11/19/2004 16:27'!
bufferType

	^ self subclassResponsibility! !

!MaObjectBuffer methodsFor: 'private' stamp: ''!
byteArray

	^byteArray! !

!MaObjectBuffer methodsFor: 'private' stamp: ''!
byteArray: aByteArray

	byteArray _ aByteArray
! !

!MaObjectBuffer methodsFor: 'accessing' stamp: 'cmm 10/21/2004 12:41'!
classId

	^self 
		uint: 16
		at: self bufferPositionOfClassId
! !

!MaObjectBuffer methodsFor: 'accessing' stamp: 'cmm 10/21/2004 12:41'!
classId: anInteger

	self
		uint: 16
		at: self bufferPositionOfClassId
		put: anInteger
! !

!MaObjectBuffer methodsFor: 'accessing' stamp: 'cmm 10/30/2004 16:00'!
classVersion

	^ 1! !

!MaObjectBuffer methodsFor: 'copying' stamp: 'cmm 10/10/2004 00:03'!
copyWithSameBuffer

	^ self copy! !

!MaObjectBuffer methodsFor: 'creation' stamp: 'cmm 11/23/2004 12:44'!
createObjectUsing: aMaObjectSerializer
	self subclassResponsibility! !

!MaObjectBuffer methodsFor: 'private' stamp: 'cmm 11/21/2004 23:29'!
ensureClassUsing: aMaObjectSerializer

	^ (aMaObjectSerializer classIdManager
		classForId: self classId
		ifAbsent:
			[ "going to materialize an instance of the missing class."
			| sourceDefinition |
			sourceDefinition _
				(aMaObjectSerializer classIdManager classDefinitionsForId: self classId) last.  "the most-recent one is the best guess."
			sourceDefinition createClassUsing: aMaObjectSerializer ])! !

!MaObjectBuffer methodsFor: 'private' stamp: 'cmm 11/21/2004 22:43'!
ensureSpaceFor: storageObject

	| totalSize requiredSpace |
	requiredSpace _ self physicalSizeFor: storageObject.
	(totalSize _ requiredSpace + self startPos) > 10000000
		ifTrue:
			 [ MaObjectSerializationSecurityViolation signal: 'Serializations beyond 10 megabytes are not allowed.' ].
	totalSize > byteArray size ifTrue: [ self growTo: totalSize*2 ].
	self physicalSize: requiredSpace! !

!MaObjectBuffer methodsFor: 'debugging' stamp: 'cmm 4/3/2003 00:09'!
equals: aMaObjectBuffer

	^(byteArray
		copyFrom: startPos + 1
		to: startPos + self physicalSize) = (
		aMaObjectBuffer byteArray
			copyFrom: startPos + 1
			to: startPos + self physicalSize)
! !

!MaObjectBuffer methodsFor: 'creation' stamp: 'cmm 11/22/2004 14:40'!
establishReferencesFrom: anObject using: aMaObjectSerializer
	"This is the second-stage of materializing anObject.  The first stage populated its instVars with oids, this stage now replaces those oids with the actual objects.  Typically, only Fixed and VariableObject buffers will need to do anything on this."! !

!MaObjectBuffer methodsFor: 'private' stamp: 'cmm 4/3/2003 00:09'!
growTo: anInteger

	self byteArray: (
		(ByteArray new: anInteger)
			replaceFrom: 1
			to: byteArray size
			with: byteArray
			startingAt: 1)
! !

!MaObjectBuffer methodsFor: 'private' stamp: ''!
headerSize
	"The number of bytes in each object record before the addresses of its
	'data' (instance variables, in the case of a NormalObjectBuffer) begins.
	The zero-based position in any buffer where the value of the object
	is stored, either the actual value or the address to it."

	^self class headerSize
! !

!MaObjectBuffer methodsFor: 'creation' stamp: ''!
independentCopy

	^self copyWithAttributes: #('byteArray')
! !

!MaObjectBuffer methodsFor: 'initializing' stamp: ''!
initialize

	super initialize.
	startPos _ 0
! !

!MaObjectBuffer methodsFor: 'reference access' stamp: 'cmm 12/2/2004 12:35'!
instVarsDoWithIndex: twoArgBlock

	1
		to: self objectInstSize
		do:
			[ :index |
			twoArgBlock
				value: (self maInstVarAt: index)
				value: index ]
! !

!MaObjectBuffer methodsFor: 'testing' stamp: 'cmm 10/21/2004 22:46'!
isBytes

	^ false! !

!MaObjectBuffer methodsFor: 'building' stamp: 'cmm 11/11/2004 16:14'!
loadFrom: aMaObjectBuffer
	"Make all of my fields the same values as those in aMaObjectBuffer.  This should be used only if you know what you're doing."
	byteArray
		replaceFrom: startPos
		to: startPos + aMaObjectBuffer physicalSize - 1
		with: aMaObjectBuffer byteArray
		startingAt: aMaObjectBuffer startPos! !

!MaObjectBuffer methodsFor: 'reference access' stamp: 'cmm 12/1/2004 23:41'!
logicalInstSize
	"Answer the capacity of this buffer to hold references to other objects."

	^ self logicalSize / self slotSize! !

!MaObjectBuffer methodsFor: 'accessing' stamp: 'cmm 10/21/2004 22:14'!
logicalSize

	^ self physicalSize - self headerSize! !

!MaObjectBuffer methodsFor: 'reference access' stamp: 'cmm 10/21/2004 23:42'!
maInstVarAt: anInteger 

	^ self 
		uint: 64
		at: (self bufferPositionOfInstVarAt: anInteger)! !

!MaObjectBuffer methodsFor: 'reference access' stamp: 'cmm 10/21/2004 23:42'!
maInstVarAt: anInteger put: oid

	self
		uint: 64
		at: (self bufferPositionOfInstVarAt: anInteger)
		put: oid
! !

!MaObjectBuffer methodsFor: 'reference access' stamp: 'cmm 12/2/2004 12:35'!
objectInstSize
	"Answer the capacity of this buffer to hold references to other objects."

	^ self objectSize / self slotSize! !

!MaObjectBuffer methodsFor: 'accessing' stamp: 'cmm 12/2/2004 12:34'!
objectSize

	^ self physicalSize - self headerSize! !

!MaObjectBuffer methodsFor: 'accessing' stamp: 'cmm 1/24/2002 13:58'!
oid

	^self 
		uint: 64
		at: self bufferPositionOfOid
! !

!MaObjectBuffer methodsFor: 'building' stamp: 'cmm 1/24/2002 13:41'!
oid: anInteger

	self
		uint: 64
		at: self bufferPositionOfOid
		put: anInteger
! !

!MaObjectBuffer methodsFor: 'reference access' stamp: 'cmm 12/2/2004 12:35'!
oids
	"This method is intended for printing only.  Use oidsDoWithIndex: if you need to enumerate my oids."

	| oids |
	self objectInstSize isInteger ifFalse: [ ^ '** invalid **' ].
	oids _ OrderedCollection new.
	1
		to: self objectInstSize
		do: [ :index | oids add: (self maInstVarAt: index) ].
	^ oids! !

!MaObjectBuffer methodsFor: 'private' stamp: 'cmm 12/1/2004 22:54'!
physicalDataSizeNeededFor: storageObject

	^ storageObject maSizeIn: self! !

!MaObjectBuffer methodsFor: 'reference access' stamp: 'cmm 12/1/2004 23:39'!
physicalInstSize
	"Answer the capacity of this buffer to hold references to other objects."

	^ self logicalSize / self slotSize! !

!MaObjectBuffer methodsFor: 'accessing' stamp: 'cmm 10/20/2004 22:44'!
physicalSize
	"See method comment for more info."

	^self 
		uint: 24
		at: self bufferPositionOfPhysicalSize
! !

!MaObjectBuffer methodsFor: 'building' stamp: 'cmm 10/20/2004 22:45'!
physicalSize: anInteger

	^self
		uint: 24
		at: self bufferPositionOfPhysicalSize
		put: anInteger
! !

!MaObjectBuffer methodsFor: 'private' stamp: 'cmm 11/21/2004 22:25'!
physicalSizeFor: storageObject

	^ self headerSize + (self physicalDataSizeNeededFor: storageObject)! !

!MaObjectBuffer methodsFor: 'building' stamp: 'cmm 11/21/2004 18:53'!
populateBodyFor: storageObject using: aMaObjectSerializer
	self subclassResponsibility! !

!MaObjectBuffer methodsFor: 'building' stamp: 'cmm 10/21/2004 23:16'!
populateHeaderFor: anObject storageObject: storageObject using: aMaObjectSerializer
	"physicalSize was already set in ensureSpaceFor:, no need to calculate it again."
	self
		oid: (aMaObjectSerializer oidFor: anObject) ;
		type: self bufferType ;
		classId:
			(aMaObjectSerializer classIdManager
				idForClass: anObject maSerializationClass
				ifAbsent: [ (aMaObjectSerializer classIdManager addNewClass: anObject maSerializationClass) id ])! !

!MaObjectBuffer methodsFor: 'printing' stamp: 'cmm 12/1/2004 23:43'!
printOn: aStream

	super printOn: aStream.
	self
		maPrintAttributes: #(oid classId logicalInstSize)
		on: aStream
! !

!MaObjectBuffer methodsFor: 'accessing' stamp: 'cmm 11/20/2004 11:08'!
slotSize
	^ 8! !

!MaObjectBuffer methodsFor: 'accessing' stamp: ''!
startPos

	^startPos! !

!MaObjectBuffer methodsFor: 'private' stamp: ''!
startPos: anInteger

	startPos _ anInteger
! !

!MaObjectBuffer methodsFor: 'accessing' stamp: 'cmm 10/21/2004 23:22'!
type
	"Answer the type of buffer this is.
		1=MaByteObjectBuffer
		2=MaVariableObjectBuffer
		3=MaFixedObjectBuffer"

	^ self 
		uint: 8
		at: self bufferPositionOfBufferType! !

!MaObjectBuffer methodsFor: 'building' stamp: 'cmm 1/24/2002 13:41'!
type: anInteger

	self
		uint: 8
		at: self bufferPositionOfBufferType
		put: anInteger
! !

!MaObjectBuffer methodsFor: 'private' stamp: 'cmm 4/3/2003 00:09'!
uint: numberOfBits at: position

	^byteArray
		maUint: numberOfBits
		at: self startPos + position
! !

!MaObjectBuffer methodsFor: 'private' stamp: 'cmm 4/3/2003 00:10'!
uint: numberOfBits at: zeroBasedIndexPosition put: valueInteger

	^byteArray
		maUint: numberOfBits
		at: self startPos + zeroBasedIndexPosition
		put: valueInteger
! !

MaObjectBuffer subclass: #MaVariableBuffer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma object serialization-support'!

!MaVariableBuffer commentStamp: 'cmm 12/1/2004 23:13' prior: 0!
This class encapsulates an object that has a variable logical size, primarily Smalltalk collections including Byte-oriented collections such as ByteArray and String.

I add no additional fields, only behavior.!

MaVariableBuffer subclass: #MaByteObjectBuffer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma object serialization-support'!

!MaByteObjectBuffer commentStamp: '<historical>' prior: 0!
I encapsulate objects that represented as a series of bytes; such as Strings, ByteArrays, CompiledMethods, etc.

!

!MaByteObjectBuffer methodsFor: 'converting' stamp: 'cmm 12/1/2004 22:47'!
asByteArray

	^ self asByteObject: ByteArray! !

!MaByteObjectBuffer methodsFor: 'converting' stamp: 'cmm 11/2/2004 15:21'!
asByteObject: byteClass

	^ self fillByteObject: (byteClass new: self logicalSize)! !

!MaByteObjectBuffer methodsFor: 'converting' stamp: 'cmm 12/1/2004 22:47'!
asString

	^ self asByteObject: String! !

!MaByteObjectBuffer methodsFor: 'accessing' stamp: 'cmm 11/19/2004 15:32'!
bufferType
	^ 1! !

!MaByteObjectBuffer methodsFor: 'creation' stamp: 'cmm 11/23/2004 22:41'!
createObjectUsing: aMaObjectSerializer
	"Objects with byte-based storage-objects can and do materialize now, rather than pointer-based storage-objects, which aren't actually well-formed until after establishingReferencesFrom:."
	^ (self ensureClassUsing: aMaObjectSerializer)
		maMaterializeFrom: self
		using: aMaObjectSerializer! !

!MaByteObjectBuffer methodsFor: 'private' stamp: 'cmm 4/3/2003 00:10'!
fillByteObject: byteObject

	^byteObject
		replaceFrom: 1
		to: byteObject size
		with: byteArray
		startingAt: self startPos + self headerSize + 1.
! !

!MaByteObjectBuffer methodsFor: 'testing' stamp: 'cmm 10/8/2004 12:09'!
isBytes

	^ true! !

!MaByteObjectBuffer methodsFor: 'actions' stamp: 'cmm 11/21/2004 19:04'!
populateBodyFor: storageObject using: aMaObjectSerializer

	self
		replaceFrom: 1
		to: storageObject size
		with: storageObject
		startingAt: 1! !

!MaByteObjectBuffer methodsFor: 'private' stamp: 'cmm 4/3/2003 00:10'!
replaceFrom: startInteger to: endInteger with: byteObject startingAt: startingInteger

	byteArray
		replaceFrom: self startPos + self headerSize + startInteger
		to: self startPos + self headerSize + endInteger
		with: byteObject
		startingAt: startingInteger
! !

!MaByteObjectBuffer methodsFor: 'accessing' stamp: 'cmm 11/20/2004 11:08'!
slotSize

	^ 1! !

!MaVariableBuffer methodsFor: 'accessing' stamp: 'cmm 11/20/2004 12:41'!
numberToStoreFor: anObject using: aMaObjectSerializer
	"This method stores either anObject itself or the oid for anInteger."
	self subclassResponsibility! !

MaVariableBuffer subclass: #MaVariableObjectBuffer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma object serialization-support'!

!MaVariableObjectBuffer commentStamp: 'cmm 10/21/2004 22:05' prior: 0!
This class encapsulates variably-sized objects that reference objects.

My buffer fields are (these are 0-based indexes, sorry):

	(see superclass)
	24 = inst var #1!

!MaVariableObjectBuffer methodsFor: 'accessing' stamp: 'cmm 11/19/2004 15:33'!
bufferType
	^ 2! !

!MaVariableObjectBuffer methodsFor: 'creation' stamp: 'cmm 11/23/2004 12:44'!
createObjectUsing: aMaObjectSerializer
	| class |
	class _ self ensureClassUsing: aMaObjectSerializer.
	"Set and Dictionary are special-case for this because we store their logical rather than physical representation.  Therefore, dispatch to the class to build the skeleton for VariableObjectBuffers."
	^ class maLoadVariableObjectFrom: self! !

!MaVariableObjectBuffer methodsFor: 'creation' stamp: 'cmm 11/23/2004 10:28'!
establishReferencesFrom: anObject using: aMaObjectSerializer
	"Set and Dictionary require special-case processing, therefore we dispatch."
	anObject maEstablishPointerReferencesUsing: aMaObjectSerializer! !

!MaVariableObjectBuffer methodsFor: 'accessing' stamp: 'cmm 11/20/2004 12:41'!
numberToStoreFor: anObject using: aMaObjectSerializer
	^ aMaObjectSerializer oidFor: anObject! !

!MaVariableObjectBuffer methodsFor: 'building' stamp: 'cmm 11/28/2004 16:21'!
populateBodyFor: storageObject using: aMaObjectSerializer
	"Logical storage of collections varies by collection, therefore dispatch back to it."
	storageObject
		maStreamVariablyInto: self
		for: aMaObjectSerializer! !

!MaVariableObjectBuffer methodsFor: 'printing' stamp: 'cmm 12/1/2004 23:43'!
printOn: aStream

	super printOn: aStream.
	self
		maPrintAttributes: #(oids)
		on: aStream
! !

MaVariableBuffer subclass: #MaVariableWordBuffer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma object serialization-support'!

!MaVariableWordBuffer methodsFor: 'as yet unclassified' stamp: 'cmm 11/19/2004 15:06'!
bufferPositionOfInstVarAt: anInteger
	"Answer the physical 0-based byte-position within the receivers byteArray
	where the instVar with index anInteger is located."

	^ self headerSize + ((anInteger - 1) * self wordSize)
! !

!MaVariableWordBuffer methodsFor: 'as yet unclassified' stamp: 'cmm 11/19/2004 15:33'!
bufferType
	^ 5! !

!MaVariableWordBuffer methodsFor: 'as yet unclassified' stamp: 'cmm 12/2/2004 12:35'!
createObjectUsing: aMaObjectSerializer
	| answer |
	answer _ (self ensureClassUsing: aMaObjectSerializer) basicNew: self objectInstSize.
	1 to: self objectInstSize do:
		[ : x |
		answer
			basicAt: x
			put: (self wordAt: x) ].
	^ answer! !

!MaVariableWordBuffer methodsFor: 'as yet unclassified' stamp: 'cmm 11/19/2004 15:12'!
maInstVarAt: logicalPosition

	^ self wordAt: logicalPosition! !

!MaVariableWordBuffer methodsFor: 'as yet unclassified' stamp: 'cmm 11/19/2004 15:12'!
maInstVarAt: logicalPosition put: anInteger

	^ self
		wordAt: logicalPosition
		put: anInteger! !

!MaVariableWordBuffer methodsFor: 'as yet unclassified' stamp: 'cmm 11/20/2004 12:41'!
numberToStoreFor: anInteger using: aMaObjectSerializer

	^ anInteger! !

!MaVariableWordBuffer methodsFor: 'as yet unclassified' stamp: 'cmm 11/21/2004 19:19'!
populateBodyFor: storageObject using: aMaObjectSerializer

	1
		to: storageObject maInstSize
		do:
			[ :index |
			self
				wordAt: index
				put: (storageObject instVarAt: index) ]! !

!MaVariableWordBuffer methodsFor: 'as yet unclassified' stamp: 'cmm 11/19/2004 17:28'!
printOn: aStream

	super printOn: aStream.
	self
		maPrintAttributes: #(words)
		on: aStream! !

!MaVariableWordBuffer methodsFor: 'as yet unclassified' stamp: 'cmm 11/20/2004 11:08'!
slotSize

	^ 4! !

!MaVariableWordBuffer methodsFor: 'as yet unclassified' stamp: 'cmm 11/19/2004 15:10'!
wordAt: logicalPosition

	^ self 
		uint: 32
		at: (self bufferPositionOfInstVarAt: logicalPosition)! !

!MaVariableWordBuffer methodsFor: 'as yet unclassified' stamp: 'cmm 11/19/2004 15:09'!
wordAt: logicalPosition put: anInteger

	self
		uint: 32
		at: (self bufferPositionOfInstVarAt: logicalPosition)
		put: anInteger! !

!MaVariableWordBuffer methodsFor: 'as yet unclassified' stamp: 'cmm 11/19/2004 15:06'!
wordSize
	^ 4! !

!MaVariableWordBuffer methodsFor: 'as yet unclassified' stamp: 'cmm 12/2/2004 12:35'!
words
	"This is intended for printing only."
	self objectInstSize isInteger ifFalse: [ ^ '** invalid **' ].
	^ (1 to: self objectInstSize) collect: [ : index | self maInstVarAt: index ]! !

MaObject subclass: #MaObjectSerializer
	instanceVariableNames: 'oidManager classIdManager preMadeObjectBuffers graphBuffer createProxyBlock traversalStrategy amBusy truncatedObjects preferences'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma object serialization-API'!

!MaObjectSerializer class methodsFor: 'creation' stamp: 'cmm 10/15/2002 22:15'!
new

	^self new: 1000
! !

!MaObjectSerializer class methodsFor: 'creation' stamp: ''!
new: anInteger

	^super new optimumByteArraySize: anInteger
! !

!MaObjectSerializer class methodsFor: 'debugging' stamp: 'cmm 10/15/2004 12:54'!
testMaterialize: anObject

	| s1 graphBuffer |

	s1 _ self new.
	graphBuffer _ s1 serializeGraph: anObject.
	^self new
		classDefinitionsByteArray: s1 classDefinitionsByteArray;
		materializeGraph: graphBuffer byteArray copy! !

!MaObjectSerializer methodsFor: 'private' stamp: 'cmm 11/28/2004 19:18'!
append: anObject
	"Append only anObject to the receiver.  However, in the case where anObject is stored via a storage-object (see #maAsStorageObject), the entire graph of the storage object must be stored."

	| storageObject |
	storageObject _ anObject maAsStorageObject.
	anObject maWantsPreSerialization ifTrue: [ self preSerialize: storageObject ].
	(storageObject ~~ anObject and: [ storageObject class isPointers "(because bytes can already be stored as-is)" ])
		ifTrue:
			[ "This is a first-class storage object, so serialize it into a ByteArray and make *that* the storage object."
			storageObject _ (self copyWithNewBuffer serializeGraph: storageObject) trimmedByteArray ].
	self graphBuffer increaseBufferSizeBy:
		(self
			bufferFor: anObject
			storageObject: storageObject
			startingAt: self graphBuffer bufferSize)
				physicalSize.
	"Since the need is so scarce anyway, if you order pre-serialization, you get post too."
	anObject maWantsPreSerialization ifTrue: [ self postSerialize: storageObject ]! !

!MaObjectSerializer methodsFor: 'private' stamp: 'cmm 11/29/2004 17:12'!
appendGraph: anObject do: oneArgBlock
	"Answer a MaSerializedObjectBuffer containing anObject and all objects
	it can reach, serialized into aByteArray."

	self beBusy.
	anObject
		maGraphDo:
			[ : path : parent : index |
			(path last
				maShouldAppendWithPath: path
				parent: parent
				index: index)
				ifTrue:
					[ self append: path last.
					oneArgBlock value: path last ] ]
		using: self traversalStrategy.
	self beBored.
	^ self graphBuffer! !

!MaObjectSerializer methodsFor: 'private' stamp: 'cmm 5/29/2002 23:22'!
beBored

	amBusy _ false
! !

!MaObjectSerializer methodsFor: 'private' stamp: 'cmm 5/29/2002 23:33'!
beBusy

	amBusy _ true
! !

!MaObjectSerializer methodsFor: 'private' stamp: 'cmm 11/21/2004 22:38'!
bufferFor: anObject storageObject: storageObject startingAt: anInteger

	| buffer |
	buffer _ (storageObject maSelectPreMadeObjectBufferFrom: self)
		startPos: anInteger ;
		ensureSpaceFor: storageObject.
	buffer byteArray == self byteArray
		ifFalse:
			[ "aByteArray must not have been big enough.."
			self byteArray: buffer byteArray ].
	buffer
		populateHeaderFor: anObject
		storageObject: storageObject
		using: self.
	buffer
		populateBodyFor: storageObject
		using: self.
	^ buffer! !

!MaObjectSerializer methodsFor: 'accessing' stamp: ''!
byteArray

	^self graphBuffer byteArray
! !

!MaObjectSerializer methodsFor: 'accessing' stamp: ''!
byteArray: aByteArray

	self graphBuffer byteArray: aByteArray.
	preMadeObjectBuffers do: [ :each | each byteArray: aByteArray ]
! !

!MaObjectSerializer methodsFor: 'accessing' stamp: 'cmm 6/8/2004 21:14'!
classDefinitionsByteArray
	"Answer a ByteArray that can be used to reinitialize a new instance of the receiver so that it can materialize the objects it has serialized."

	^ (
self copyWithNewBuffer serializeGraph: self classIdManager classDefinitionsById) trimmedByteArray! !

!MaObjectSerializer methodsFor: 'initializing' stamp: 'cmm 6/8/2004 22:09'!
classDefinitionsByteArray: aByteArray
	"Initialize the receiver with aByteArray that materializes to my classDefinitions.  These are the classDefinitions used to work with objects that were being used when the user saved off the byteArray by calling the getter, #classDefinitionsByteArray."

	self classDefinitions: (self materializeGraph: aByteArray)! !

!MaObjectSerializer methodsFor: 'accessing' stamp: 'cmm 5/23/2004 22:18'!
classDefinitionsOid

	^self oidFor: self classIdManager classDefinitionsById! !

!MaObjectSerializer methodsFor: 'private' stamp: 'cmm 11/1/2004 11:39'!
classFor: anObject

	^ anObject isBehavior ifTrue: [ anObject maSerializationClass ] ifFalse: [ anObject class ]! !

!MaObjectSerializer methodsFor: 'accessing' stamp: ''!
classIdManager

	^classIdManager
! !

!MaObjectSerializer methodsFor: 'building' stamp: ''!
classIdManager: aMaClassIdManager

	classIdManager _ aMaClassIdManager
! !

!MaObjectSerializer methodsFor: 'copying' stamp: 'cmm 12/29/2002 16:56'!
copyWithNewBuffer

	^(self copyWithAttributes: #('graphBuffer'))
		initializePreMadeObjectBuffers;
		resetByteArray;
		beBored! !

!MaObjectSerializer methodsFor: 'copying' stamp: 'cmm 11/15/2004 15:46'!
copyWithNewOidSpace
	"Answer a new instance of the me that shares my class-ids, but not the oids."
	
	^ self copyWithNewBuffer
		oidManager: oidManager class new ;
		yourself! !

!MaObjectSerializer methodsFor: 'actions' stamp: 'cmm 1/20/2003 22:26'!
finalizeOids

	oidManager finalizeOids! !

!MaObjectSerializer methodsFor: 'accessing' stamp: ''!
graphBuffer

	^graphBuffer
! !

!MaObjectSerializer methodsFor: 'building' stamp: ''!
graphBuffer: aMaSerializedGraphBuffer

	graphBuffer _ aMaSerializedGraphBuffer
! !

!MaObjectSerializer methodsFor: 'event handling' stamp: 'cmm 12/12/2004 18:54'!
handleClassModification: aModifiedClassDefinitionEvent

	aModifiedClassDefinitionEvent isModified ifFalse: [ ^ self ].
	aModifiedClassDefinitionEvent item isMeta ifTrue: [ ^ self ].
	oidManager
		handleClassModification: aModifiedClassDefinitionEvent item
		using: self.
	classIdManager
		handleClassModification: aModifiedClassDefinitionEvent item
		using: self! !

!MaObjectSerializer methodsFor: 'testing' stamp: 'cmm 7/17/2002 22:49'!
hasOidFor: anObject

	^oidManager hasOidFor: anObject! !

!MaObjectSerializer methodsFor: 'copying' stamp: 'cmm 3/20/2003 21:55'!
independentCopy
	"Answer a completely independent copy of the receiver.  This will probably
	mostly be used during debugging."

	| copy |
	copy _
		self copy
			oidManager: oidManager independentCopy;
			classIdManager: self classIdManager independentCopy;
			resetByteArray.
	^copy
		copyAttributes: #('graphBuffer' 'traversalStrategy')
		from: self! !

!MaObjectSerializer methodsFor: 'initializing' stamp: 'cmm 11/26/2004 12:06'!
initialize

	super initialize.
	self
		oidManager: MaOidManager new;
		classIdManager: MaClassIdManager new;
		initializeTraversalStrategy;
		toCreateProxies: [ :oid | self error: 'No createProxyBlock specified.  See MaObjectSerializer>>toCreateProxies:' ].
	self graphBuffer: (MaSerializedGraphBuffer new: 50).
	self initializePreMadeObjectBuffers.
	self beBored.
	truncatedObjects _ WeakIdentityKeyDictionary new  "want a WeakIdentitySet..".
	preferences _ MaObjectSerializerPreferences new.
	self setUpPreAndPostProcessing! !

!MaObjectSerializer methodsFor: 'initializing' stamp: 'cmm 10/21/2004 12:53'!
initializePreMadeObjectBuffers

	preMadeObjectBuffers _ MaObjectBuffer bufferClasses collect:
		[ :each |
		each
			byteArray: self byteArray
			startPos: 0 ]
! !

!MaObjectSerializer methodsFor: 'building' stamp: 'cmm 11/29/2004 11:04'!
initializeTraversalStrategy
	traversalStrategy _
		MaObjectGraphTraversalStrategy new
			traverseWhen:
				[ : path : parent : indexInteger | 
				path last
					maShouldTraverseWithPath: path
					parent: parent
					index: indexInteger ]! !

!MaObjectSerializer methodsFor: 'testing' stamp: 'cmm 6/5/2004 17:26'!
isTruncated: anObject
	"A truncated object is one that has been read, but the in-image definition did not have a place for one of its inst vars.  This is useful for then detecting if the user tries to write that object back out to warn him that he will lose data."

	^ truncatedObjects includesKey: anObject! !

!MaObjectSerializer methodsFor: 'materializing' stamp: 'cmm 10/9/2004 23:58'!
materializeGraph: aByteArray

	^self
		materializeGraph: aByteArray
		do: [ : eachObject : eachBuffer | "do nothing" ]
! !

!MaObjectSerializer methodsFor: 'materializing' stamp: 'cmm 10/9/2004 22:03'!
materializeGraph: aByteArray do: twoArgBlock
	"Guard against stepping on my own buffers if I'm busy serializing or materializing already."

	^amBusy
		ifTrue:
			[ self copyWithNewBuffer
				byteArray: aByteArray;
				materializeGraphDo: twoArgBlock ]
		ifFalse:
			[ self
				byteArray: aByteArray;
				materializeGraphDo: twoArgBlock ]
! !

!MaObjectSerializer methodsFor: 'private' stamp: 'cmm 11/29/2004 17:25'!
materializeGraphDo: twoArgBlock
	"Materialize as much as the object in the receivers byteArray as possible.  For each object *materialized*, value twoArgBlock [ : eachObject : eachBuffer | ].  twoArgBlock is not valued for objects encountered in the materialized graph if they were already present in the receivers oidManager, that way we know when objects are exactly materialized."

	| skeletons rootObject needToRehash |
	needToRehash _ false.
	skeletons _ OrderedCollection new: 48.
	rootObject _ nil.
	self beBusy.
	self graphBuffer buffersDo:
		[ : each | | object |
		object _
			self
				objectWithOid: each oid
				ifFound:
					[ : foundObj |
					foundObj maIsBufferedObjectProxy "true when materializing a proxy"
						ifTrue: [ skeletons add: (self newSkeletonFor: each fromProxy: foundObj) -> each copyWithSameBuffer ].
					foundObj ]
				ifAbsent:
					[ | newObject |
					skeletons add: (newObject _ self newSkeletonFor: each fromProxy: nil) -> each copyWithSameBuffer.
					newObject ].
		rootObject ifNil: [ rootObject _ object ] ].
	"Do not merge these do's.."
	skeletons do:
		[ : eachAssociation |  | eachObject eachBuffer |
		eachObject _ eachAssociation key.
		eachBuffer _ eachAssociation value.
		(eachObject maIsHashedCollection and: [ eachObject notEmpty ]) ifTrue: [ needToRehash _ true ].
		eachBuffer
			establishReferencesFrom: eachObject
			using: self ].
	needToRehash ifTrue:
		[ skeletons do:
			[ : eachAssociation | 
			eachAssociation key maIsHashedCollection ifTrue: [ eachAssociation key rehash ] ] ].
	skeletons do:
		[ : eachAssociation |  | eachFullyFormedObject eachBuffer |
		eachFullyFormedObject _ eachAssociation key.  eachBuffer _ eachAssociation value.
		eachFullyFormedObject maWantsPostMaterialization ifTrue: [ self postMaterialize: eachFullyFormedObject ].
		twoArgBlock
			value: eachFullyFormedObject
			value: eachBuffer "up to user to copy this if they need to." ].
	self beBored.
	^ rootObject! !

!MaObjectSerializer methodsFor: 'private' stamp: 'cmm 11/23/2004 12:50'!
newSkeletonFor: aMaObjectBuffer fromProxy: aMaBufferedObjectProxy

	| skel |
	skel _ aMaObjectBuffer createObjectUsing: self.
	aMaBufferedObjectProxy ifNotNil: [ aMaBufferedObjectProxy becomeForward: skel copyHash: false ].
	self
		oidOf: skel
		is: aMaObjectBuffer oid.
	^ skel! !

!MaObjectSerializer methodsFor: 'accessing' stamp: 'cmm 3/20/2003 21:55'!
objectWithOid: anInteger ifAbsent: aBlock

	^oidManager
		objectWithOid: anInteger
		ifAbsent: aBlock
! !

!MaObjectSerializer methodsFor: 'accessing' stamp: 'cmm 3/20/2003 21:54'!
objectWithOid: anInteger ifFound: oneArgBlock ifAbsent: aBlock

	^oidManager
		objectWithOid: anInteger
		ifFound: oneArgBlock
		ifAbsent: aBlock
! !

!MaObjectSerializer methodsFor: 'private' stamp: 'cmm 12/29/2004 14:26'!
objectsDo: oneArgBlock
	oidManager objectsDo: oneArgBlock! !

!MaObjectSerializer methodsFor: 'accessing' stamp: 'cmm 4/20/2003 22:18'!
oidCount
	"Answers the number of objects that have oids."

	^oidManager oidCount! !

!MaObjectSerializer methodsFor: 'accessing' stamp: 'cmm 3/20/2003 21:54'!
oidFor: anObject

	^oidManager oidFor: anObject
! !

!MaObjectSerializer methodsFor: 'building' stamp: ''!
oidManager: aMaOidManager

	oidManager _ aMaOidManager
! !

!MaObjectSerializer methodsFor: 'private' stamp: 'cmm 6/23/2004 17:41'!
oidOf: anObject is: anInteger

	oidManager
		oidOf: anObject
		is: anInteger! !

!MaObjectSerializer methodsFor: 'building' stamp: 'cmm 12/29/2002 16:49'!
optimumByteArraySize: anInteger

	self byteArray: (ByteArray new: anInteger).
	self resetByteArray! !

!MaObjectSerializer methodsFor: 'private' stamp: 'cmm 11/28/2004 19:10'!
postMaterialize: anObject
	"maPostMaterialize could be useful for when you don't necessarily require serialization, but needed so that it *can* be used, if desired."
	(anObject respondsTo: #maPostMaterialize) ifTrue: [ anObject maPostMaterialize ].
	anObject class withAllSuperclassesDo:
		[ : eachClass |
		preferences postMaterializers
			maAt: eachClass
			ifPresent: [ : valuators | valuators do: [ : each | each value: anObject ] ]
			ifAbsent: [ "do nothing" ] ]! !

!MaObjectSerializer methodsFor: 'private' stamp: 'cmm 11/28/2004 19:16'!
postSerialize: anObject
	"maPostSerialize could be useful for when you don't necessarily require serialization, but needed so that it *can* be used, if desired."
	(anObject respondsTo: #maPostSerialize) ifTrue: [ anObject maPostSerialize ].
	anObject class withAllSuperclassesDo:
		[ : eachClass |
		preferences postSerializers
			maAt: eachClass
			ifPresent: [ : valuators | valuators do: [ : each | each value: anObject ] ]
			ifAbsent: [ "do nothing" ] ]! !

!MaObjectSerializer methodsFor: 'private' stamp: 'cmm 11/11/2004 15:42'!
preMadeByteObjectBuffer

	^ self preMadeObjectBufferAt: 1! !

!MaObjectSerializer methodsFor: 'private' stamp: 'cmm 11/11/2004 15:43'!
preMadeClassObjectBuffer

	^ self preMadeObjectBufferAt: 4! !

!MaObjectSerializer methodsFor: 'private' stamp: 'cmm 11/11/2004 15:43'!
preMadeFixedObjectBuffer

	^ self preMadeObjectBufferAt: 3! !

!MaObjectSerializer methodsFor: 'private' stamp: 'cmm 11/11/2004 15:42'!
preMadeObjectBufferAt: bufferTypeInteger

	^ preMadeObjectBuffers at: bufferTypeInteger! !

!MaObjectSerializer methodsFor: 'private' stamp: 'cmm 11/11/2004 15:43'!
preMadeVariableObjectBuffer

	^ self preMadeObjectBufferAt: 2! !

!MaObjectSerializer methodsFor: 'private' stamp: 'cmm 11/19/2004 15:27'!
preMadeVariableWordBuffer

	^ self preMadeObjectBufferAt: 5! !

!MaObjectSerializer methodsFor: 'private' stamp: 'cmm 11/28/2004 19:10'!
preSerialize: anObject
	"maPreserialize could be useful for when you don't necessarily require serialization, but needed so that it *can* be used, if desired."
	(anObject respondsTo: #maPreserialize) ifTrue: [ anObject maPreserialize ].
	anObject class withAllSuperclassesDo:
		[ : eachClass |
		preferences preSerializers
			maAt: eachClass
			ifPresent: [ : valuators | valuators do: [ : each | each value: anObject ] ]
			ifAbsent: [ "do nothing" ] ]! !

!MaObjectSerializer methodsFor: 'accessing' stamp: 'cmm 11/26/2004 09:46'!
preferences
	^ preferences! !

!MaObjectSerializer methodsFor: 'accessing' stamp: 'cmm 4/23/2003 23:16'!
proxyFor: oid

	^oidManager retainIdentityOfProxy: (createProxyBlock value: oid)
! !

!MaObjectSerializer methodsFor: 'building' stamp: 'cmm 6/5/2004 17:27'!
recordTruncatedObject: anObject
	"A truncated object is one that has been read, but the in-image definition did not have a place for one of its inst vars.  This is useful for then detecting if the user tries to write that object back out to warn him that he will lose data.  See also isTruncated:."

	truncatedObjects at: anObject put: nil! !

!MaObjectSerializer methodsFor: 'actions' stamp: 'cmm 12/29/2004 17:30'!
rehashOids

	oidManager rehashOids! !

!MaObjectSerializer methodsFor: 'actions' stamp: 'cmm 11/26/2004 09:43'!
resetByteArray
	"Ensure my preMade buffers share the same byteArray as my graphBuffer (a performance optimization) and set my size to 0 objects."
	preMadeObjectBuffers first byteArray ~~ self byteArray
		ifTrue: [ preMadeObjectBuffers do: [ :each | each byteArray: self byteArray ] ].
	self graphBuffer resetBufferSize! !

!MaObjectSerializer methodsFor: 'actions' stamp: 'cmm 3/20/2003 21:54'!
resetOidManager
	"If receiving a byteArray from another serializer, this method should
	be invoked prior to materializing here so cached oids in the oidManager
	that may not match the objects that were serialized by the other
	serializer.  MaClientServerOidManager avoids the need to do this, once connected."

	oidManager reset
! !

!MaObjectSerializer methodsFor: 'serializing' stamp: ''!
serializeGraph: anObject
	"Answer a MaSerializedGraphBuffer containing anObject and all objects
	it can reach, serialized into aByteArray."

	^self
		serializeGraph: anObject
		do: [ :each | nil ]
! !

!MaObjectSerializer methodsFor: 'serializing' stamp: 'cmm 11/16/2004 23:39'!
serializeGraph: anObject do: oneArgBlock
	"Answer a MaSerializedGraphBuffer containing anObject and all objects it can reach, serialized into aByteArray."

	^ self copyWithNewBuffer
		resetByteArray;
		appendGraph: anObject
		do: oneArgBlock! !

!MaObjectSerializer methodsFor: 'initializing' stamp: 'cmm 11/29/2004 23:19'!
setUpPreAndPostProcessing
	preferences
		afterMaterializingAny: MaClassDefinition
		do:
			[ : aMaClassDefinition |
			classIdManager addClassDefinition: aMaClassDefinition ].
	preferences
		beforeSerializingAny: Color
		do: [ : aColor | aColor flushCache ].
	preferences
		beforeSerializingAny: ColorForm
		do: [ : aColorForm | aColorForm clearColormapCache ].
	preferences
		beforeSerializingAny: ScriptEditorMorph
		do:
			[ : aScriptEditorMorph |
			aScriptEditorMorph class = BooleanScriptEditor ifFalse: [ aScriptEditorMorph hibernate ] ].
	preferences
		afterSerializingAny: ScriptEditorMorph
		do: [ : aScriptEditorMorph | aScriptEditorMorph class = BooleanScriptEditor ifFalse: [ aScriptEditorMorph unhibernate ] ].
	preferences
		afterMaterializingAny: ScriptEditorMorph
		do: [ : aScriptEditorMorph | aScriptEditorMorph class = BooleanScriptEditor ifFalse: [ aScriptEditorMorph unhibernate ] ].
	preferences
		beforeSerializingAny: ViewerFlapTab
		do: [ : aViewerFlapTab | aViewerFlapTab hibernate ].
	preferences
		afterSerializingAny: ViewerFlapTab
		do: [ : aViewerFlapTab | aViewerFlapTab unhibernate ].
	preferences
		afterMaterializingAny: ViewerFlapTab
		do: [ : aViewerFlapTab | aViewerFlapTab unhibernate ].
	preferences
		afterMaterializingAny: Project
		do:
			[ : aProject |
			"This behavior suggested by ImageSegment>>#comeFullyUpOnReload:"
			aProject ensureChangeSetNameUnique.
			Project addingProject: aProject.
			aProject restoreReferences.
			self maMarked: 'dev'.  "need to restore dependents??"
			ScriptEditorMorph writingUniversalTiles: 
				((aProject projectPreferenceAt: #universalTiles) ifNil: [false]) ].
	preferences
		beforeSerializingAny: EToyProjectHistoryMorph
		do: [ : anEToyProjectHistoryMorph | anEToyProjectHistoryMorph removeAllMorphs ].
	preferences
		afterSerializingAny: EToyProjectHistoryMorph
		do: [ : anEToyProjectHistoryMorph | anEToyProjectHistoryMorph rebuild ].
	preferences
		afterMaterializingAny: EToyProjectHistoryMorph
		do: [ : anEToyProjectHistoryMorph | anEToyProjectHistoryMorph rebuild ].! !

!MaObjectSerializer methodsFor: 'testing' stamp: 'cmm 12/29/2004 14:27'!
sharesAnyObjectsWith: anotherMaObjectSerializer
	anotherMaObjectSerializer objectsDo:
		[ : each |
		(self hasOidFor: each) ifTrue: [ ^ true ] ].
	self objectsDo:
		[ : each |
		(anotherMaObjectSerializer hasOidFor: each) ifTrue: [ ^ true ] ].
	^ false! !

!MaObjectSerializer methodsFor: 'building' stamp: ''!
toCreateProxies: oneArgBlock

	createProxyBlock _ oneArgBlock
! !

!MaObjectSerializer methodsFor: 'accessing' stamp: ''!
traversalStrategy

	^traversalStrategy
! !

MaObject subclass: #MaObjectSerializerPreferences
	instanceVariableNames: 'preSerializers postSerializers postMaterializers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma object serialization-API'!

!MaObjectSerializerPreferences methodsFor: 'pre and post processing' stamp: 'cmm 11/26/2004 15:24'!
afterMaterializingAny: aClass do: oneArgValuator
	"Set up preference for materializing instances of aClass by sending oneArgValuator.  The first argument is the object being serialized, the second is the serializer (aMaObjectSerializer) doing the serialization."
	(postMaterializers
		at: aClass
		ifAbsentPut: [ OrderedCollection new ])
	
		add: oneArgValuator! !

!MaObjectSerializerPreferences methodsFor: 'pre and post processing' stamp: 'cmm 11/28/2004 17:11'!
afterSerializingAny: aClass do: oneArgValuator
	"Set up preference for serializing instances of aClass by sending oneArgValuator.  The first argument is the object being serialized, the second is the serializer (aMaObjectSerializer) doing the serialization."
	(postSerializers
		at: aClass
		ifAbsentPut: [ OrderedCollection new ])
	
		add: oneArgValuator! !

!MaObjectSerializerPreferences methodsFor: 'pre and post processing' stamp: 'cmm 11/26/2004 12:32'!
beforeSerializingAny: aClass do: oneArgValuator
	"Set up preference for serializing instances of aClass by sending oneArgValuator.  The first argument is the object being serialized, the second is the serializer (aMaObjectSerializer) doing the serialization."
	(preSerializers
		at: aClass
		ifAbsentPut: [ OrderedCollection new ])
	
		add: oneArgValuator! !

!MaObjectSerializerPreferences methodsFor: 'initializing' stamp: 'cmm 11/28/2004 19:22'!
initialize
	super initialize.
	preSerializers _ Dictionary new.
	postSerializers _ Dictionary new.
	postMaterializers _ Dictionary new! !

!MaObjectSerializerPreferences methodsFor: 'pre and post processing' stamp: 'cmm 11/26/2004 10:17'!
postMaterializers
	^ postMaterializers! !

!MaObjectSerializerPreferences methodsFor: 'pre and post processing' stamp: 'cmm 11/28/2004 17:12'!
postSerializers
	^ postSerializers! !

!MaObjectSerializerPreferences methodsFor: 'pre and post processing' stamp: 'cmm 11/26/2004 10:17'!
preSerializers
	^ preSerializers! !

!MaObjectSerializerPreferences methodsFor: 'pre and post processing' stamp: 'cmm 11/26/2004 15:24'!
releasePostMaterializationFor: aClass
	"Remove all post-materialization behaviors for aClass."
	postMaterializers
		removeKey: aClass
		ifAbsent: [ "ok" ]! !

!MaObjectSerializerPreferences methodsFor: 'pre and post processing' stamp: 'cmm 11/28/2004 17:18'!
releasePostSerializationFor: aClass
	"Remove all post-materialization behaviors for aClass."
	postSerializers
		removeKey: aClass
		ifAbsent: [ "ok" ]! !

!MaObjectSerializerPreferences methodsFor: 'pre and post processing' stamp: 'cmm 11/26/2004 15:25'!
releasePreserializationFor: aClass
	"Remove all preserialization behaviors for aClass."
	preSerializers
		removeKey: aClass
		ifAbsent: [ "ok" ]! !

MaObject subclass: #MaOidCalculator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma object serialization-support'!

!MaOidCalculator commentStamp: 'cmm 12/1/2004 11:04' prior: 0!
The oid ranges are as follows:

The range from (0 to: SmallInteger maxVal - SmallInteger minVal) are reserved for:  user objects, the non-integral atomics including 65536 characters and space for 2000000 new-object oids (bigger than any transaction should ever be!!).  We should allow a few thousand for future-use as well.

SmallInteger minVal actually starts at the oid with the value SmallInteger maxVal + 1.  Thus, SmallInteger maxVal has the oid

We start at the bottom so user-objects are contiguous above 
 
  a   n u m b e r   l i n e
|<--- SmallInteger range -------------->|< - - - - - -  LargeInteger range - - - - - - - - - ->|
atomics, chars, new objects, future  |    u s e r  o b j e c t s   | Floats | SmallIntegers  |

0
	nil
1
	false
2
	true
3 to: 65538
	DB character-set (only SB currently supported)
65539
	indicate an unused slot in a MaHashIndex
65540 to: 66540
	future use?
66541 to: 66541 + 2000000
	new-object oids
2066542 to: 18446744067266100672 (oid for smallest float - 1)
	user objects
18446744067266100673 to: 18446744071561067967
	32-bit IEEE floats
18446744071561067968 to: 18446744073708551615
	SmallIntegers
!

!MaOidCalculator class methodsFor: 'special' stamp: 'cmm 8/6/2002 23:39'!
firstCharacterOid

	^3! !

!MaOidCalculator class methodsFor: 'floats' stamp: 'cmm 8/8/2002 23:01'!
floatFromOid: anInteger

	^Float fromIEEE32Bit: anInteger - self oidForSmallestFloat! !

!MaOidCalculator class methodsFor: 'integers' stamp: 'cmm 8/6/2002 23:52'!
integerFromOid: oidInteger

	^oidInteger - self oidForZero! !

!MaOidCalculator class methodsFor: 'floats' stamp: 'cmm 8/8/2002 23:36'!
isOidForFloat: oidInteger

	^oidInteger
		between: self oidForSmallestFloat
		and:  18446744071561067967  "self oidForSmallestOptimizedInteger - 1"! !

!MaOidCalculator class methodsFor: 'integers' stamp: 'cmm 8/8/2002 22:28'!
isOidForOptimizedInteger: oidInteger

	^oidInteger
		between: self oidForSmallestOptimizedInteger  "self oidForZero + SmallInteger minVal"
		and: 18446744073708551615  "self oidForZero + SmallInteger maxVal"! !

!MaOidCalculator class methodsFor: 'integers' stamp: 'cmm 8/6/2002 23:44'!
isOptimizedInteger: anInteger

	^anInteger class = SmallInteger! !

!MaOidCalculator class methodsFor: 'special' stamp: 'cmm 8/6/2002 23:39'!
lastCharacterOid

	"^self firstCharacterOid + 65535"   "DBCS"
	^65538! !

!MaOidCalculator class methodsFor: 'oids' stamp: 'cmm 9/1/2002 22:54'!
newOidMinimum

	^66541! !

!MaOidCalculator class methodsFor: 'oids' stamp: 'cmm 8/8/2002 22:57'!
objectWithOid: anInteger ifNone: aBlock

	anInteger == self oidForNil ifTrue: [ ^nil ].
	anInteger == self oidForFalse ifTrue: [ ^false ].
	anInteger == self oidForTrue ifTrue: [ ^true ].
	(self isOidForFloat: anInteger)
		ifTrue:
			[ ^self floatFromOid: anInteger ].
	(self isOidForOptimizedInteger: anInteger)
		ifTrue:
			[ ^self integerFromOid: anInteger ].
	(anInteger
		between: self firstCharacterOid
		and: self lastCharacterOid)
			ifTrue:
				[ ^Character value: anInteger - self firstCharacterOid ].
	^aBlock value! !

!MaOidCalculator class methodsFor: 'oids' stamp: 'cmm 8/6/2002 23:40'!
oidForCharacter: aCharacter

	^self firstCharacterOid + aCharacter asciiValue! !

!MaOidCalculator class methodsFor: 'oids' stamp: 'cmm 8/6/2002 23:41'!
oidForFalse

	^1! !

!MaOidCalculator class methodsFor: 'floats' stamp: 'cmm 8/8/2002 23:06'!
oidForFloat: aFloat

	^aFloat asIEEE32BitWord + self oidForSmallestFloat! !

!MaOidCalculator class methodsFor: 'integers' stamp: 'cmm 8/6/2002 23:51'!
oidForInteger: anInteger

	^anInteger + self oidForZero! !

!MaOidCalculator class methodsFor: 'oids' stamp: 'cmm 8/6/2002 23:37'!
oidForNil

	^0! !

!MaOidCalculator class methodsFor: 'floats' stamp: 'cmm 8/8/2002 23:02'!
oidForSmallestFloat

	^18446744067266100673  "self oidForSmallestOptimizedInteger - 16rFFFFFFFF"! !

!MaOidCalculator class methodsFor: 'integers' stamp: 'cmm 8/8/2002 22:29'!
oidForSmallestOptimizedInteger

	^18446744071561067968! !

!MaOidCalculator class methodsFor: 'oids' stamp: 'cmm 8/6/2002 23:41'!
oidForTrue

	^2! !

!MaOidCalculator class methodsFor: 'integers' stamp: 'cmm 8/6/2002 23:54'!
oidForZero

	"^16rFFFFFFFFFFFFFFFF - SmallInteger maxVal - 1000000"
	^ 18446744072634809792! !

!MaOidCalculator class methodsFor: 'special' stamp: 'cmm 8/6/2002 23:38'!
specialValueForUnusedHashIndexEntry

	^3! !

MaObject subclass: #MaOidManager
	instanceVariableNames: 'objects oids nextOid'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma object serialization-support'!

!MaOidManager methodsFor: 'actions' stamp: 'cmm 1/20/2003 22:28'!
finalizeOids

	oids finalizeValues! !

!MaOidManager methodsFor: 'private' stamp: 'cmm 8/11/2002 18:28'!
getNextOid

	^nextOid _ nextOid + 1! !

!MaOidManager methodsFor: 'event handling' stamp: 'cmm 6/24/2004 11:59'!
handleClassModification: aClass using: aMaObjectSerializer
	"optional subclass responsibility"! !

!MaOidManager methodsFor: 'testing' stamp: 'cmm 7/17/2002 22:51'!
hasOidFor: anObject

	^oids includesKey: anObject! !

!MaOidManager methodsFor: 'creation' stamp: 'cmm 11/15/2004 15:18'!
independentCopy

	^ (self copyWithAttributes: #('objects' 'oids')) resetNextOid; yourself! !

!MaOidManager methodsFor: 'private' stamp: 'cmm 1/20/2003 21:12'!
initialize

	super initialize.
	self
		reset;
		resetNextOid! !

!MaOidManager methodsFor: 'accessing' stamp: 'cmm 12/27/2002 16:03'!
objectWithOid: anInteger ifAbsent: aBlock

	^self
		objectWithOid: anInteger
		ifFound: [ :foundObj | foundObj ]
		ifAbsent: aBlock! !

!MaOidManager methodsFor: 'accessing' stamp: 'cmm 12/25/2002 12:15'!
objectWithOid: anInteger ifFound: oneArgBlock ifAbsent: aBlock

	^MaOidCalculator
		objectWithOid: anInteger
		ifNone:
			[ objects
				maAt: anInteger
				ifPresent:
					[ :obj |
					obj   "oid key marked to be cleaned"
						ifNil: [ aBlock value ]
						ifNotNil: [ oneArgBlock value: obj ] ]
				ifAbsent: [ aBlock value ] ]! !

!MaOidManager methodsFor: 'actions' stamp: 'cmm 12/29/2004 13:54'!
objectsDo: oneArgBlock

	objects do: oneArgBlock! !

!MaOidManager methodsFor: 'accessing' stamp: 'cmm 4/20/2003 22:18'!
oidCount

	^oids size! !

!MaOidManager methodsFor: 'accessing' stamp: ''!
oidFor: anObject

	^self
		oidFor: anObject
		ifAbsent:
			[ self
				oidOf: anObject
				is: self getNextOid ]
! !

!MaOidManager methodsFor: 'accessing' stamp: 'cmm 10/24/2002 23:11'!
oidFor: anObject ifAbsent: aBlock

	anObject maIsBufferedObjectProxy ifTrue: [ ^anObject oid ].
	^anObject maRequiresOwnBuffer
		ifTrue:
			[ oids
				maAt: anObject
				ifPresent: [ :oid | oid ifNil: [ aBlock value ] ifNotNil: [ oid ] ]
				ifAbsent: aBlock ]
		ifFalse:
			[ anObject maOid ]
! !

!MaOidManager methodsFor: 'building' stamp: 'cmm 5/8/2003 13:57'!
oidOf: anObject is: anInteger

	objects size > (oids size * 2) ifTrue: [ self removeGarbageCollectedObjectEntries ].
	objects
		at: anInteger
		put: anObject.
	^oids
		at: anObject
		put: anInteger! !

!MaOidManager methodsFor: 'actions' stamp: 'cmm 12/29/2004 17:29'!
rehashOids

	oids rehash! !

!MaOidManager methodsFor: 'private' stamp: 'cmm 3/20/2003 12:58'!
removeGarbageCollectedObjectEntries

	objects _ objects reject: [ :each | each isNil ]! !

!MaOidManager methodsFor: 'actions' stamp: 'cmm 12/12/2002 22:34'!
reset
	"When dealing with other serializers, their oid managers have different ideas on what
	oids of objects should be.  That's why we clear out all the oids from the previous serialization
	activity."

	oids _ MaWeakIdentityKeyDictionary new.
	objects _ MaWeakValueDictionary new
! !

!MaOidManager methodsFor: 'private' stamp: ''!
resetNextOid

	nextOid _ MaOidCalculator newOidMinimum
! !

!MaOidManager methodsFor: 'building' stamp: 'cmm 9/9/2002 23:59'!
retainIdentityOfProxy: aMaBufferedObjectProxy

	^objects
		at: aMaBufferedObjectProxy oid
		put: aMaBufferedObjectProxy! !

MaObject subclass: #MaSerializedGraphBuffer
	instanceVariableNames: 'byteArray'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma object serialization-support'!

!MaSerializedGraphBuffer commentStamp: '<historical>' prior: 0!
Header:

	total physical size of this buffer.  Necessary because we otherwise have no
	way of knowing where the actual end of the buffer is.
!

!MaSerializedGraphBuffer class methodsFor: 'private accessing' stamp: 'cmm 9/22/2002 23:52'!
headerSize
	"header only has 32-bit integer representing the physicalSize of my byteArray that holds the entire serialized graph."

	^4! !

!MaSerializedGraphBuffer class methodsFor: 'creation' stamp: ''!
new: anInteger

	^self new resetByteArray: (ByteArray new: anInteger)
! !

!MaSerializedGraphBuffer methodsFor: 'private actions' stamp: 'cmm 10/21/2004 12:52'!
bufferPositionsDo: oneArgBlock

	"Value oneArgBlock with the value of the starting position of each
	buffer in the receiver."

	| pos end |

	pos _ self headerSize.
	end _ self bufferSize - 1.
	[ pos <= end ] whileTrue:
		[ oneArgBlock value: pos.
		pos _
			pos +
				(byteArray 
					maUint: 24
					at: pos + MaObjectBuffer bufferPositionOfPhysicalSize) ]
! !

!MaSerializedGraphBuffer methodsFor: 'accessing' stamp: 'cmm 4/3/2003 00:10'!
bufferSize

	^byteArray 
		maUint: 32
		at: 0
! !

!MaSerializedGraphBuffer methodsFor: 'private building' stamp: 'cmm 4/3/2003 00:11'!
bufferSize: anInteger

	byteArray
		maUint: 32
		at: 0
		put: anInteger
! !

!MaSerializedGraphBuffer methodsFor: 'private accessing' stamp: 'cmm 10/21/2004 12:52'!
bufferTypeAt: startPositionOfObjectBuffer

	^byteArray
		maUint: 8
		at: startPositionOfObjectBuffer + MaObjectBuffer bufferPositionOfBufferType! !

!MaSerializedGraphBuffer methodsFor: 'creation' stamp: ''!
buffers

	| coll |

	coll _ OrderedCollection new.
	self buffersDo: [ :each | coll add: each copy ].
	^coll
! !

!MaSerializedGraphBuffer methodsFor: 'actions' stamp: 'cmm 4/3/2003 00:11'!
buffersDo: oneArgBlock
	"Value oneArgBlock with each ObjectBuffer in the
	receiver.  There is one ObjectBuffer for each object in the graph that
	the receiver represents."

	| preMadeBuffers |
	preMadeBuffers _ self newPremadeBuffers.
	self bufferPositionsDo:
		[ :eachPosition | | buffer |
		buffer _ (preMadeBuffers at: (self bufferTypeAt: eachPosition)).
		buffer
			byteArray: byteArray;
			startPos: eachPosition.
		oneArgBlock value: buffer ]! !

!MaSerializedGraphBuffer methodsFor: 'accessing' stamp: ''!
byteArray
	"One ByteArray holds the entire graph of objects."

	^byteArray
! !

!MaSerializedGraphBuffer methodsFor: 'building' stamp: ''!
byteArray: aByteArray

	byteArray _ aByteArray
! !

!MaSerializedGraphBuffer methodsFor: 'private creation' stamp: 'cmm 4/23/2002 19:46'!
copy

	^self copyWithAttributes: #('byteArray')
! !

!MaSerializedGraphBuffer methodsFor: 'private accessing' stamp: 'cmm 7/16/2002 21:42'!
headerSize

	^self class headerSize
! !

!MaSerializedGraphBuffer methodsFor: 'building' stamp: ''!
increaseBufferSizeBy: anInteger

	self bufferSize: self bufferSize + anInteger
! !

!MaSerializedGraphBuffer methodsFor: 'private creation' stamp: 'cmm 10/21/2004 12:52'!
newPremadeBuffers

	^MaObjectBuffer bufferClasses collect: [ :each | each new ]
! !

!MaSerializedGraphBuffer methodsFor: 'printing' stamp: 'cmm 4/3/2003 00:11'!
printOn: aStream

	| buffers |

	super printOn: aStream.
	byteArray notNil
		ifTrue:
			[ buffers _ self buffers.
			aStream
				nextPutAll: ' (';
				maPrint: buffers size;
				nextPutAll: ' objects in ';
				maPrint: self bufferSize;
				nextPutAll: ' bytes)'.
			buffers notEmpty
				ifTrue:
					[ aStream tab.
					buffers first maPrintAbbreviatedOn: aStream ] ]
! !

!MaSerializedGraphBuffer methodsFor: 'building' stamp: ''!
resetBufferSize
	"Reset the current pointer (which is the bufferSize) back to the beginning."

	self bufferSize: self headerSize
! !

!MaSerializedGraphBuffer methodsFor: 'building' stamp: ''!
resetByteArray: aByteArray

	self
		byteArray: aByteArray;
		resetBufferSize
! !

!MaSerializedGraphBuffer methodsFor: 'accessing' stamp: 'cmm 4/3/2003 00:11'!
trimmedByteArray

	^byteArray
		copyFrom: 1
		to: self bufferSize! !

!UndefinedObject class methodsFor: '*ma object serialization' stamp: 'cmm 6/11/2004 13:57'!
maInstancesRequireOwnBuffer

	^ false! !

!UndefinedObject methodsFor: '*ma object serialization' stamp: ''!
maOid
	^MaOidCalculator oidForNil! !

!IdentitySet methodsFor: '*ma object serialization' stamp: 'cmm 6/28/2004 23:21'!
maIsEqualityHashedCollection

	^ false! !

MaUserError subclass: #MaObjectSerializationUserError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma object serialization-exceptions'!

!BlockContext class methodsFor: '*ma object serialization' stamp: 'cmm 11/15/2004 15:21'!
maMaterializeFrom: aMaByteObjectBuffer using: aMaObjectSerializer

	^ (aMaObjectSerializer copyWithNewOidSpace materializeGraph: aMaByteObjectBuffer asByteArray) asBlockContext! !

!BlockContext methodsFor: '*ma object serialization' stamp: 'cmm 11/10/2004 12:01'!
maAsStorageObject

	^ MaBlockContextStorage newFor: self! !

PackageInfo subclass: #MaObjectSerializationPackageInfo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma object serialization-Info'!

!MaObjectSerializationPackageInfo methodsFor: 'as yet unclassified' stamp: 'cmm 1/29/2003 23:37'!
prerequisitePackages

	^#('Ma proxy support' 'Ma special collections' 'Ma traverse object graphs')! !

!MaObjectSerializationPackageInfo methodsFor: 'as yet unclassified' stamp: 'cmm 1/30/2003 00:41'!
readmeText

	^'I am a general object serialization and materialization framework.  Currently, I convert objects to ByteArrays and back.  I am used by both the "Ma client server" and "Magma" packages.  I offer a lot of flexibility in the way objects are serialized and materialized, even to the way the object graphs are traversed during serialization (courtesy of "Ma object serialization").

The major class is MaObjectSerializer, see it for more information.  It utilizes a MaDefaultOidManager, a MaDefaultClassIdManager, and a MaObjectGraphTraversalStrategy to create a MaSerializedGraphBuffer, the final object that wraps the ByteArray.'! !

!True methodsFor: '*ma object serialization' stamp: ''!
maOid

	^MaOidCalculator oidForTrue
! !

!SmallInteger class methodsFor: '*ma object serialization' stamp: 'cmm 6/11/2004 13:57'!
maInstancesRequireOwnBuffer

	^ false! !

!SmallInteger class methodsFor: '*ma object serialization' stamp: 'cmm 6/2/2004 16:54'!
maMaterializeFrom: aMaByteObjectBuffer using: aMaObjectSerializer

	^MaOidCalculator
		objectWithOid: aMaByteObjectBuffer oid
		ifNone: [ self error: aMaByteObjectBuffer , ' is not a buffer for a SmallInteger.' ]
! !

!IdentityBag methodsFor: '*ma object serialization' stamp: 'cmm 6/28/2004 23:20'!
maIsEqualityHashedCollection

	^ false! !

!False methodsFor: '*ma object serialization' stamp: ''!
maOid

	^MaOidCalculator oidForFalse
! !

!WeakIdentityKeyDictionary methodsFor: '*ma object serialization' stamp: 'cmm 6/28/2004 23:22'!
maIsEqualityHashedCollection

	^ false! !

!MaWeakIdentityKeyDictionary methodsFor: '*ma object serialization' stamp: 'cmm 6/28/2004 23:21'!
maIsEqualityHashedCollection

	^ false! !

!EToyProjectHistoryMorph methodsFor: '*ma object serialization' stamp: 'cmm 11/29/2004 23:28'!
maWantsPostMaterialization 
	^ true! !

!EToyProjectHistoryMorph methodsFor: '*ma object serialization' stamp: 'cmm 11/29/2004 22:38'!
maWantsPreSerialization 
	^ true! !

!Character class methodsFor: '*ma object serialization' stamp: 'cmm 6/11/2004 13:57'!
maInstancesRequireOwnBuffer

	^ false! !

!Character methodsFor: '*ma object serialization' stamp: ''!
maOid

	^MaOidCalculator oidForCharacter: self
! !

!ProcessorScheduler class methodsFor: '*ma object serialization' stamp: 'cmm 11/23/2004 12:37'!
maMaterializeFrom: aMaByteObjectBuffer using: aMaObjectSerializer

	^ Processor! !

!ProcessorScheduler methodsFor: '*ma object serialization' stamp: 'cmm 12/19/2002 23:13'!
maAsStorageObject
	"We don't even need to store the name of the global.  It's class
	gives it away."

	^String maEmpty
! !

!ProcessorScheduler methodsFor: '*ma object serialization' stamp: 'cmm 11/29/2004 11:01'!
maUsesStandardStorage

	^ false! !

!Metaclass class methodsFor: '*ma object serialization' stamp: 'cmm 10/27/2004 23:40'!
maMaterializeFrom: aMaClassReferenceBuffer using: aMaObjectSerializer

	^ (Class
		maMaterializeFrom: aMaClassReferenceBuffer
		using: aMaObjectSerializer) class! !

!Metaclass methodsFor: '*ma object serialization' stamp: 'cmm 10/27/2004 22:57'!
maInstancesRequireOwnBuffer

	^ true! !

!Metaclass methodsFor: '*ma object serialization' stamp: 'cmm 10/27/2004 22:53'!
maSerializationClass

	^ Metaclass! !

!Metaclass methodsFor: '*ma object serialization' stamp: 'cmm 11/29/2004 11:01'!
maUsesStandardStorage

	^ false! !

!Integer methodsFor: '*ma object serialization' stamp: ''!
maOid

	^MaOidCalculator oidForInteger: self
! !

!MethodContext class methodsFor: '*ma object serialization' stamp: 'cmm 11/15/2004 15:21'!
maMaterializeFrom: aMaByteObjectBuffer using: aMaObjectSerializer

	^ (aMaObjectSerializer copyWithNewOidSpace materializeGraph: aMaByteObjectBuffer asByteArray) asMethodContext! !

!MethodContext methodsFor: '*ma object serialization' stamp: 'cmm 11/10/2004 12:02'!
maAsStorageObject

	^ MaMethodContextStorage newFor: self! !

!SystemDictionary class methodsFor: '*ma object serialization' stamp: 'cmm 11/23/2004 12:37'!
maMaterializeFrom: aMaByteObjectBuffer using: aMaObjectSerializer

	^ Smalltalk! !

!SystemDictionary methodsFor: '*ma object serialization' stamp: 'cmm 12/19/2002 23:13'!
maAsStorageObject
	"We don't even need to store the name of the global.  It's class
	gives it away."

	^String maEmpty
! !

!SystemDictionary methodsFor: '*ma object serialization' stamp: 'cmm 11/29/2004 11:01'!
maUsesStandardStorage

	^ false! !

!UUID class methodsFor: '*ma object serialization' stamp: 'cmm 11/23/2004 12:47'!
maMaterializeFrom: aMaByteObjectBuffer using: aMaObjectSerializer

	^ self fromString: aMaByteObjectBuffer asString! !

!UUID methodsFor: '*ma object serialization' stamp: 'cmm 11/7/2004 23:33'!
maAsStorageObject

	^ self asString! !

!UUID methodsFor: '*ma object serialization' stamp: 'cmm 11/29/2004 11:39'!
maUsesStandardStorage

	^ false! !

!TranscriptStream class methodsFor: '*ma object serialization' stamp: 'cmm 11/23/2004 12:37'!
maMaterializeFrom: aMaByteObjectBuffer using: aMaObjectSerializer

	^ Transcript! !

!TranscriptStream methodsFor: '*ma object serialization' stamp: 'cmm 12/19/2002 23:13'!
maAsStorageObject
	"We don't even need to store the name of this global.  It's class
	gives it away."

	^String maEmpty! !

!TranscriptStream methodsFor: '*ma object serialization' stamp: 'cmm 11/29/2004 11:01'!
maUsesStandardStorage

	^ false! !
MaObjectBuffer initialize!
